program imregist
  
  ! Original version by M. Hamabe 1999-07-23 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-07-20 (for Fortran90)
  ! Updated by M. Hamabe  2007-07-23 (opninp)
  ! Updated by H. Shimizu 2007-11-02 (reg-files)

  real, allocatable :: Ga(:,:), Gb(:,:), Gwork(:,:)
  character :: image1*80, image2*80, image*80
  character :: yn, comments*50, outfile*80
  character :: mode,titleA*40, titleB*40, imode*6
  character :: device*20, intr*3, rregs*40, vregs*40
  integer   :: im1, im2, nim, irc, bitpix
  real(8)   :: AA(6),a0
  real(4)   :: Xa(100),Ya(100),Xb(100),Yb(100)
  
  !     *** Set logical unit number ***
  
  NLP =16
  IFLG=-999                 ! flag for the window which is not opened yet
  device='/XWINDOW'         ! device for display/plot
  ipal=1                    ! default color palett
  IW1=IFLG                  ! wiondow-1 is not opened yet
  IW2=IFLG                  ! wiondow-2 is not opened yet
  
  call opninp (1,im1,0,image1,titleA,iextA,jextA,irc) ! $B4p=`2hA|(Bopen
  if ( irc/=0 ) go to 999
  call opninp (2,im2,0,image2,titleB,iextB,jextB,irc) ! $BBP>]2hA|(Bopen
  if ( irc/=0 ) go to 999
  
  call clargc (3, image, irc)            ! $B=PNO(B($BJQ49(B)$B2hA|L>FI$_9~$_(B
  if ( irc /= 0 ) then
     print '(''Enter       output   image name: '',$)'
     read *, image
  end if
  
  call clargc (4, intr, irc)        
  if ( irc /= 0 ) then
     intr='yes'
     irc=0
  end if
  
  if ( intr=='no' ) then
     call clargc (5, rregs, irc)        
     if ( irc /= 0 ) then
        print '(''Enter ds9 reg-file(reference): '',$)'
        read *, rregs
        irc=0
     end if
     call clargc (6, vregs, irc)
     if ( irc /= 0 ) then
        print '(''Enter ds9 reg-file(victim): '',$)'
        read *, vregs   
        irc=0
     end if
  end if
  
  call clargc (7, imode, irc)           ! $BJQ49%b!<%I$NA*Br(B
  if ( irc /= 0 ) then
     print '(''Enter mode of registration ===> '',$)'
     read '(a)', imode
  end if
  

  call opniaf(image,'rgst',outfile,NLP,irc) ! $B=PNO%U%!%$%k(B($B%Q%i%a!<%?MQ(B)open
  if ( irc /= 0 ) stop
  
  allocate( Ga(iextA, jextA) )   
  call MATRD(im1,Ga,iextA,jextA,irc)        ! $B4p=`2hA|FI$_9~$_(B
  if ( irc /= 0 ) go to 999
  
  call FCLOSE(im1,irc)
  if ( irc /= 0 ) go to 999
  
  allocate( Gb(iextB, jextB) )  
  call MATRD(im2,Gb,iextB,jextB,irc)       ! $BBP>]2hA|FI$_9~$_(B
  
  if ( irc /= 0 ) go to 999
  
  !     *** CHECK SIZES OF MATRICES ***
  if( iextA /= iextB.OR.jextA /= jextB ) then  ! $B2hA|%5%$%:$N%A%'%C%/(B
     print *, '### Matrix sizes are not same !!! ###'
     GO TO 9000
  end if
  iext=iextB
  jext=jextB
  ORIENT=0.0
  CENTI=iext/2.
  CENTJ=jext/2.
  PXSI=1.0
  PXSJ=1.0
  
  KEXT=100
  
  if ( intr=='yes' ) then
     
     !     *** DISPLAY STATISTICS ON TERMINAL ***
     call SPG_OPN(IW1,IFLG,device)
     if ( iext >= (jext*1.75) ) then
        width=10.5
        ratio=float(jext)/float(iext)*1.25
     else if ( iext >= jext .or. jext < (iext*1.2) ) then
        width=7.5
        ratio=float(jext)/float(iext)*1.2
     else
        hight=12.0
        ratio=float(jext)/float(iext)*1.1
        width=hight/ratio
     end if
     
     !     Set up graphics device to display image.
     call PGPAP(width, ratio)     ! set the size and aspect
     call PGSVP(0.0,1.0,0.0,1.0)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     
     IS=iext/8
     ie=iext/3
     JS=jext/8
     JE=jext/3
     FACT=3.0
     NCYCLE=2
     call STATRJ(Ga,iext,jext,IS,IE,JS,JE,FACT,NCYCLE,  &
          &      GMAX,GMIN,GMEAN,GSD,NREJ,irc)
     amin=gmean-gsd
     amax=gmax+50*gsd
     
777  print *, 'displaying REFERENCE image....'
     print '(''z1='',f12.3,''  z2='',F12.3)', amin, amax
     
     call SPG_DSP(Ga,IEXT,JEXT,TITLEa,amin,amax,IPAL,IW,1,1,iext,jext)
     
     print '(''Is display level OK? (<y>/n) '',$)'
     read '(a)', yn
     if ( yn == 'n' ) then
        print '(''z1,z2 = '',$)'
        read *, amin,amax
        goto 777
     end if
     
     call SPG_OPN(IW2,IFLG,device)
     call PGPAP(width, ratio)  ! set the size and aspect
     call PGSVP(0.0,1.0,0.0,1.0)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     call STATRJ(Gb,iext,jext,IS,IE,JS,JE,FACT,NCYCLE, &
          &      GMAX,GMIN,GMEAN,GSD,NREJ,irc)
     bmin=gmean-gsd
     bmax=gmax+50*gsd

     
888  print *, 'displaying VICTIM image....'
     print '(''z1='',f12.3,''  z2='',F12.3)', bmin, bmax
     
     call SPG_DSP(Gb,IEXT,JEXT,TITLEb,bmin,bmax,IPAL,IW,1,1,iext,jext)
     
     print '(''Is display level OK? '',$)'
     read '(a)', yn
     if ( yn == 'n' ) then
        print '(''z1,z2 = '',$)'
        read *, bmin,bmax
        goto 888
     end if
     
  end if
  
  !     *** $B:BI8JQ49%b!<%I$NA*Br(B ***
  MODE='1'                            ! $BJ?9T0\F0$N$_(B
  if ( imode(1:1) == 'r' ) MODE='2'   ! $BJ?9T0\F0(B + $B2sE>(B
  if ( imode(1:1) == 'm' ) MODE='3'   ! $BJ?9T0\F0(B + $B2sE>(B + $B3HBg=L>.(B
  if(MODE == '2') then
     print *, '*** MODE : Rotaion and Shift ***'
     write(NLP,'(///1H ,15X,"*** TRANSFORMATION MODE ***"/ &
          &     1H ,15X,"   ROTATION & SHIFT        ")')
  else if(MODE == '3') then
     print *, '*** MODE : Rotaion, shift and magnification ***'
     write(NLP,'(///1H ,15X,"*** TRANSFORMATION MODE ***"/ &
          &     1H ,15X,"ROTATION & SHIFT & MAGNIFY ")')
  else
     print *, '*** MODE : Shift ***'
     MODE='1'
     write(NLP,'(///1H ,15X,"*** TRANSFORMATION MODE ***"/ &
          &     1H ,15X,"      SHIFT                ")')
  end if
  
  
  allocate( Gwork(iext, jext) )   ! ptr3=malloc(iext*jext*4)
  call EXETRAN(Ga,Gb,Gwork,iext,jext,MODE,CENTI,CENTJ,PXSI,PXSJ, &
       &       ORIENT,Xa,Ya,Xb,Yb,KEXT,a0,AA,NP,amin,amax,bmin,bmax, &
       &       rregs,vregs,IW1,IW2,intr,irc)
  deallocate(Ga)  ! call free(ptr1)
  deallocate(Gwork)  ! call free(ptr3)
  if (irc == 999) go to 9000
  
  write(NLP,730) NP,a0,AA(1)/a0,AA(2)/a0,AA(3)/a0,AA(4)/a0,AA(5),AA(6)
  !     
730 FORMAT(///1H ,15X,'*******************    REF.POINTS = ',I3// &
         &     1H ,15X,' | U |        | A1  A2 |   | X |   | A5 |'/ &
         &     1H ,15X,' |   | = A0 * |        | * |   | + |    |'/ &
         &     1H ,15X,' | V |        | A3  A4 |   | Y |   | A6 |'/ &
         &     1H ,15X,'      A0= ',G15.8/ &
         &     1H ,15X,'      A1= ',G15.8/ &
         &     1H ,15X,'      A2= ',G15.8/ &
         &     1H ,15X,'      A3= ',G15.8/ &
         &     1H ,15X,'      A4= ',G15.8/ &
         &     1H ,15X,'      A5= ',G15.8/ &
         &     1H ,15X,'      A6= ',G15.8)
  
  if ( intr=='yes' ) then
     call PGSLCT(IW2)
     call SPG_DSP(Gb,IEXT,JEXT,TITLEb,bmin,bmax,IPAL,IW,1,1,iext,jext)
     
     print '(''OK? '',$)'
     read '(a)', yn
     if ( yn == 'n' ) then
        print *, 'registered image will not be saved.'
        call PGEND
        call system('\\rm '//outfile)
        stop
     end if
  end if
  
  bitpix=-32
  call IMGCOPY(im2,nim,bitpix,image,irc)
  if ( irc /= 0 ) goto 999
  
  call FCLOSE(im2,irc)
  if ( irc /= 0 ) goto 999
  
  if ( MODE == '2' ) then
     comments='MODE: SHIFT AND ROTATION'
  else if ( MODE == '3' ) then
     comments='MODE: SHIFT, ROTATION AND RESIZE'
  else
     comments='MODE: SHIFT ONLY'
  end if
  call adhstry(nim,'IMREGIST',8,comments,irc)
  comments='REFERENCE IMAGE: '//image1
  call adhstry(nim,'IMREGIST',0,comments,irc)
  comments='VICTIM    IMAGE: '//image2
  call adhstry(nim,'IMREGIST',0,comments,irc)
  comments='(most part of the header is for the victim)'
  call adhstry(nim,'IMREGIST',0,comments,irc)
  
  
  call MATWT (nim,Gb,iext,jext,irc)
  deallocate(Gb)  ! call free(ptr2)
  if ( irc /= 0 ) go to 999
  
  call FCLOSE(nim,irc)
  if ( irc /= 0 ) go to 999
  
  call PGEND
  
9000 STOP
  
999 call PUTEMSG(irc)
  call PGEND
  stop
  
END program imregist

!----------------------------------------------------------------------
SUBROUTINE EXETRAN(Ga,Gb,Gwork,iext,jext,MODE,CENTI,CENTJ,PXSI,PXSJ, &
     &             ORIENT,Xa,Ya,Xb,Yb,KEXT,a0,AA,NP,amin,amax,bmin,bmax, &
     &             rregs,vregs,IW1,IW2,intr,irc)
  
  character :: MODE, intr*(*), rregs*(*), vregs*(*)
  real(4)   :: Ga(iext,jext), Gb(iext,jext), Gwork(iext,jext)
  real(4)   :: Xa(KEXT), Ya(KEXT), Xb(KEXT), Yb(KEXT)
  real(8)   :: AA(6), a0
  
  irc=0 
  
  if( intr(1:1)=='y' ) then
     call RDCENTER(Ga,Gb,iext,jext,Xa,Ya,Xb,Yb,NA,NB,KEXT, &
          &     amin,amax,bmin,bmax,IW1,IW2)
  else
     call RDREGS(Ga,Gb,iext,jext,Xa,Ya,Xb,Yb,NA,NB,KEXT,rregs,vregs)
  end if

  NP=NA
  if( NA/=NB ) NP=MIN(NA,NB)
  print *
  print *, '    REFERENCE POINTS = ',NP
  if( NP <= 0 ) then
     print *
     print *, '--- Transformation cannot be executed ! ---'
     AA(1)=1.0D0
     AA(2)=0.0D0
     AA(3)=0.0D0
     AA(4)=1.0D0
     AA(5)=0.0D0
     AA(6)=0.0D0
     irc=999
     GO TO 5000
  end if
  
  !     *** TRANSFORM IMAGE B ***
  call TRANSB(Gb,Gwork,iext,jext,MODE,Xa,Ya,Xb,Yb,NP,a0,AA)
  
  !     *** TRANSFORM PARAMETERS ***
  call TRANSP(AA,CENTI,CENTJ,PXSI,PXSJ,ORIENT)
  !
5000 CONTINUE
  !
  return
END SUBROUTINE EXETRAN
!----------------------------------------------------------------------
SUBROUTINE TRANSP(AA,CENTI,CENTJ,PXSI,PXSJ,ORIENT)
  !
  !     *** TRANSFORM PARAMETERS ***
  !
  IMPLICIT real*8 (A)
  dimension AA(6)
  !
  !     *** TRANSFORM PARAMETERS ***
  ADET=AA(1)*AA(4)-AA(2)*AA(3)
  API=PXSI**2
  APJ=PXSJ**2
  PXSI=SQRT(AA(4)*AA(4)*API+AA(3)*AA(3)*APJ)/ABS(ADET)
  PXSJ=SQRT(AA(2)*AA(2)*API+AA(1)*AA(1)*APJ)/ABS(ADET)
  ACENTI=CENTI
  ACENTJ=CENTJ
  CENTI=AA(1)*ACENTI+AA(2)*ACENTJ+AA(5)
  CENTJ=AA(3)*ACENTI+AA(4)*ACENTJ+AA(6)
  AORI=ORIENT/57.29578
  O1=AA(1)*SIN(AORI)+AA(2)*COS(AORI)
  O2=AA(3)*SIN(AORI)+AA(4)*COS(AORI)
  call ARCTAN(O2,O1,ORIENT,IRC)
  if( IRC /= 0 ) then
     print *, '### ERROR ###   ( ORIENT IS NOT DEFINED )'
     ORIENT=0.0
  end if

  return

END SUBROUTINE TRANSP

!---------------------------------------------------------------------
SUBROUTINE TRANSB(Gb,Gwork,iext,jext,MODE,Xa,Ya,Xb,Yb,NP,a0,AA)

  !     *** TRANSFORM IMAGE B ***

  real(4)   :: Gb(iext,jext),Gwork(iext,jext), Xa(NP),Ya(NP),Xb(NP),Yb(NP)
  character :: MODE
  real(8)   :: AA(6),a0

  !     *** DETERMINE TRANSFORM PARAMETERS ***
  print *
  if(MODE == '2'.AND.NP >= 2) then
     a0=1.0d0
     print *, '*** transformation parameters = 3 ***'
     call ORTRAN(Xa,Ya,Xb,Yb,NP,a0,AA)
  else if(MODE == '3'.AND.NP >= 2) then
     print *, '*** transformation parameters = 4 ***'
     call getfact(xa,ya,xb,yb,np,a0)
     print *, 'magnification=',a0
     call ORTRAN(Xa,Ya,Xb,Yb,NP,a0,AA)
  else if(NP >= 1) then
     a0=1.0d0
     print *, '*** transformation parameters = 2 ***'
     call PARALLEL(Xa,Ya,Xb,Yb,NP,AA)
  else
     print *, '### No reference points ###'
     print *, '     Transformation is not executed'
     GO TO 1000
  end if
  
  !     *** AFFINE TRANSFORMATION ***
  call AFFINE(Gb,Gwork,iext,jext,AA,IRC)
  if(IRC /= 0) then
     print *
     print *, '### Error in AFFINE trans. ###'
     print *, '     Transformation is not executed'
  end if
  
1000 CONTINUE
  
  return

END SUBROUTINE TRANSB

!---------------------------------------------------------------------
SUBROUTINE ORTRAN(Xa,Ya,Xb,Yb,NP,a0,AA)
  
  !     *** DETERMINE TRANSFORMATION PARAMETERS (ROT. & SHIFT) ***
  !     written by M. Hamabe 1991-09-18
  
  IMPLICIT real*8 (R,S,T)
  real(4)  :: Xa(NP),Ya(NP),Xb(NP),Yb(NP)
  real(8)  :: AA(6),a0
  
  Sxx=0.0D0
  Syy=0.0D0
  Sxy=0.0D0
  Syx=0.0D0
  Sx1=0.0D0
  Sy1=0.0D0
  S1x=0.0D0
  S1y=0.0D0
  Rxx=0.0D0
  Rxy=0.0D0
  Ryy=0.0D0
  
  do N=1,NP
     Sxx=Sxx+dble(Xa(N))   *dble(Xb(N))*a0
     Syy=Syy+dble(Ya(N))   *dble(Yb(N))*a0
     Sxy=Sxy+dble(Xa(N))   *dble(Yb(N))*a0
     Syx=Syx+dble(Ya(N))   *dble(Xb(N))*a0
     Sx1=Sx1+dble(Xa(N))
     Sy1=Sy1+dble(Ya(N))
     S1x=S1x+               dble(Xb(N))*a0
     S1y=S1y+               dble(Yb(N))*a0
     Rxx=Rxx+dble(Xb(N))*a0*dble(Xb(N))*a0
     Rxy=Rxy+dble(Xb(N))*a0*dble(Yb(N))*a0
     Ryy=Ryy+dble(Yb(N))*a0*dble(Yb(N))*a0
  end do
  
  TA=Rxx*S1y-Rxy*S1x
  TB=Ryy*S1x-Rxy*S1y
  TC=Sxx*S1y-Sxy*S1x
  TD=Ryy*S1x-Rxy*S1y
  TE=Rxx*S1y-Rxy*S1x
  TF=Syy*S1x-Syx*S1y
  TAA=(TA*TE+TB*TD)
  TBB=(TC*TE+TB*TF)
  TCC=(TB*TD+TA*TE)
  TDD=(TC*TD-TA*TF)
  if ( TAA /= 0 .and. TCC /= 0 ) then
     TCOS=TBB/TAA
     TSIN=TDD/TCC
     TP=sqrt(TCOS*TCOS+TSIN*TSIN)
     TCOS=TCOS/TP
     TSIN=TSIN/TP
  else
     print *, '     Fitting failed!'
     TCOS=1.0D0
     TSIN=0.0D0
  end if
  !     
  AA(1)= TCOS*a0
  AA(2)=-TSIN*a0
  AA(3)= TSIN*a0
  AA(4)= TCOS*a0
  
  Sx=0.0D0
  Sy=0.0D0
  do N=1,NP
     Sx=Sx+Xa(N)-Xb(N)*AA(1)-Yb(N)*AA(2)
     Sy=Sy+Ya(N)-Xb(N)*AA(3)-Yb(N)*AA(4)
  end do
  SN=dble(NP)
  AA(5)=Sx/SN
  AA(6)=Sy/SN

  return

END SUBROUTINE ORTRAN

!---------------------------------------------------------------------
SUBROUTINE PARALLEL(Xa,Ya,Xb,Yb,NP,AA)
  
  !     *** DETERMINE TRANSFORMATION PARAMETERS (SHIFT) ***
  
  real(4) :: Xa(NP),Ya(NP),Xb(NP),Yb(NP)
  real(8) :: AA(6), Sx, Sy, SN
  
  Sx=0.0D0
  Sy=0.0D0
  
  do N=1,NP
     Sx=Sx+Xa(N)-Xb(N)
     Sy=Sy+Ya(N)-Yb(N)
  end do
  SN=dble(NP)
  
  AA(1)=1.0D0
  AA(2)=0.0D0
  AA(3)=0.0D0
  AA(4)=1.0D0
  AA(5)=Sx/SN
  AA(6)=Sy/SN
  
  return

END SUBROUTINE PARALLEL

!*********************************************************************
!
!                               < RDCENTER >
!
!**********************************************************************
SUBROUTINE RDCENTER(Ga,Gb,iext,jext,Xa,Ya,Xb,Yb,NA,NB,KEXT, &
     &              amin,amax,bmin,bmax,IW1,IW2)
  
  !     Written by M.Hamabe (1991-10-17)
  !     Updated by M.Hamabe (1992-04-26)
  !     Updated by M.Hamabe (1996-06-21)
  
  character :: cdum*2, yn, code
  real(4)   :: Ga(iext,jext), Gb(iext,jext)
  real(4)   :: Xa(kext),Ya(kext),Xb(kext),Yb(kext)
  
  print *, 'ab minmax', amin,amax,bmin,bmax
  
  print *, '*** Selection of reference stars ***'
  print *, ' Mouse button (key) --- function -------'
  print *, '   Left        (A)   : select ref. star'
  print *, '   Middle      (D)   : change box-size '
  print *, '   Right       (X)   : quit '
! print *, '               (c)   : cancel last entry'
  
  print '(''     Half size of box (in pixel) ===> '',$)'
  read *, iwd
  call PGSLCT(IW1)
1001 print *
  print *, '##### REFERENCE FRAME #####'
  print *, '   ID   IX   IY   W/2    Xc        Yc'
  na=0
  ibak=0
  jbak=0
  do i=1,50
     call PGCURS(x,y,code)
     ic=x
     jc=y
     if ( code == 'X' ) then
        goto 1000
!     else if ( code == 'c' ) then 
!        i=i-1
!        print '(''Entry'',i3,'' was canceled.'')', na
!        na=na-1
     else if ( code == 'D' ) then 
        print '(''     Half size of box (in pixel) ===> '',$)'
        read *, iwd
     else if ( code == 'A' ) then 
        idum=ic-iwd
        if ( idum < 1    ) idum=1
        if ( idum > iext ) idum=iext
        IL=idum
        idum=jc-iwd
        if ( idum < 1    ) idum=1
        if ( idum > jext ) idum=jext
        JL=idum
        idum=ic+iwd
        if ( idum < 1    ) idum=1
        if ( idum > iext ) idum=iext
        IH=idum
        idum=jc+iwd
        if ( idum < 1    ) idum=1
        if ( idum > jext ) idum=jext
        JH=idum
        if ( IL /= IH .and. JL /= JH .and. (ic /= ibak .or. jc /= jbak) ) then
           na=na+1
           ibak=ic
           jbak=jc
           call PGSCI(13)
           call SPG_BOX(float(IL),float(IH),float(JL),float(JH))
           write(cdum,'(i2)') na
           call PGTEXT(float(IL),float(JL+1),cdum)
           call PGSCI(1)
           call CENOFGR(Ga,iext,jext,IL,IH,JL,JH,XC,YC)
           xa(na)=xc
           ya(na)=yc
           print '(i5,3i5,2f10.3)', na,ic,jc,iwd,xa(na),ya(na)
        end if
     end if
  end do
1000 continue
  print '(''OK ? (<y>/n) ===> '',$)'
  read '(a)', yn
  if ( yn == 'n' ) go to 1001
  print *
  print *, '    Reference points on image A = ',NA
  call PGSLCT(IW2)
1002 print *
  print *, '##### VICTIM    FRAME #####'
  print *, '   ID   IX   IY   W/2    Xc        Yc'
  nb=0
  ibak=0
  jbak=0
  do i=1,50
     call PGCURS(x,y,code)
     ic=x
     jc=y
     if ( code == 'X' ) then
        goto 2000
!     else if ( code == 'c' ) then 
!        i=i-1
!        print '(''Entry'',i3,'' was canceled.'')', na
!        nb=nb-1
     else if ( code == 'D' ) then 
        print '(''     Half size of box (in pixel) ===> '',$)'
        read *, iwd
     else if ( code == 'A' ) then 
        idum=ic-iwd
        if ( idum < 1    ) idum=1
        if ( idum > iext ) idum=iext
        IL=idum
        idum=jc-iwd
        if ( idum < 1    ) idum=1
        if ( idum > jext ) idum=jext
        JL=idum
        idum=ic+iwd
        if ( idum < 1    ) idum=1
        if ( idum > iext ) idum=iext
        IH=idum
        idum=jc+iwd
        if ( idum < 1    ) idum=1
        if ( idum > jext ) idum=jext
        JH=idum
        if ( IL /= IH .and. JL /= JH .and. (ic /= ibak .or. jc /= jbak) ) then
           nb=nb+1
           ibak=ic
           jbak=jc
           call PGSCI(13)
           call SPG_BOX(float(IL),float(IH),float(JL),float(JH))
           write(cdum,'(i2)') nb
           call PGTEXT(float(IL),float(JL+1),cdum)
           call PGSCI(1)
           call CENOFGR(Gb,iext,jext,IL,IH,JL,JH,XC,YC)
           xb(nb)=xc
           yb(nb)=yc
           print '(i5,3i5,2f10.3)', nb,ic,jc,iwd,xb(nb),yb(nb)
        end if
     end if
  end do
2000 continue
  print '(''OK ? (<y>/n) ===> '',$)'
  read '(a)', yn
  if ( yn == 'n' ) go to 1002
  print *, '    Reference points on image B = ',NB
  
  if ( na == 0 .or. nb == 0 ) print *, 'No region is defined!'
  
  return

end SUBROUTINE RDCENTER

!--------------------------------------------------------------------
SUBROUTINE CENOFGR(G,iext,jext,IL,IH,JL,JH,XC,YC)
  
  !     Calculate the center of gravity in submatrix.
  
  real(4) :: g(iext,jext)
  
  cmax=-99999.0
  do i=il,ih
     if ( g(i,jl) >= cmax ) cmax=g(i,jl)
     if ( g(i,jh) >= cmax ) cmax=g(i,jh)
  end do
  do j=jl,jh
     if ( g(il,j) >= cmax ) cmax=g(il,j)
     if ( g(ih,j) >= cmax ) cmax=g(ih,j)
  end do
  
  wt=0.0
  xc=0
  yc=0
  do j=jl,jh
     do i=il,ih
        if ( g(i,j) >= cmax ) then
           wt=wt+g(i,j)
           xc=xc+float(i)*g(i,j)
           yc=yc+float(j)*g(i,j)
        end if
     end do
  end do
  xc=xc/wt
  yc=yc/wt
  
  return

end SUBROUTINE CENOFGR

!---------------------------------------------------------------
SUBROUTINE GETFACT(Xa,Ya,Xb,Yb,NP,A0)
  
  real(8) :: a0, d, da, db, diff
  real(4) :: Xa(NP), Ya(NP), Xb(NP), Yb(NP)

  diff=0
  nn=0
  do j=1, np
     xa0=xa(j)
     ya0=ya(j)
     xb0=xb(j)
     yb0=yb(j)
     do i=1, np
        if ( j /= i ) then
           d =(xa0-xa(i))*(xa0-xa(i))+(ya0-ya(i))*(ya0-ya(i))
           da=sqrt(d)
           d =(xb0-xb(i))*(xb0-xb(i))+(yb0-yb(i))*(yb0-yb(i))
           db=sqrt(d)
           diff=diff+da/db
           nn=nn+1
        end if
     end do
  end do
  a0=diff/float(nn)
  
  return

end SUBROUTINE GETFACT

!-----------------------------------------------------------------------
SUBROUTINE RDREGS(Ga,Gb,iext,jext,Xa,Ya,Xb,Yb,NA,NB,KEXT,rregs,vregs)

  character :: line*70
  character :: rregs*(*), vregs*(*)
  real(4)   :: Ga(iext,jext), Gb(iext,jext)
  real(4)   :: xa(kext), ya(kext), xb(kext), yb(kext), wid, hei
  

  ! --- REFERENCE FRAME ---
  print *
  print *, '##### REFERENCE FRAME #####'
  print *, '  ID   IX   IY   W/2    Xc        Yc'
  open(51, file=rregs)  
  na=0
  do i=1, 999
     read(51, '(a70)', end=501) line
     is=index(line, '(')+1
     ie=index(line, ')')-1
     if ( line(1:3)=='phy' ) then
        print *
        print '(''##### ERROR: change file coordinate system from "physical" for "image"'')'
        print *
        stop
     end if
     if ( line(1:3)=='box' ) then
        read(line(is:ie),*) xx, yy, wid, hei
        na=na+1
        IL=xx-wid/2
        IH=xx+wid/2
        JL=yy-hei/2
        JH=yy+hei/2
        call CENOFGR(Ga,iext,jext,IL,IH,JL,JH,XC,YC)
        xa(na)=xc
        ya(na)=yc
        print '(i5,3i5,2f10.3)', na,nint(xx),nint(yy),nint(wid),xa(na),ya(na)
     else if ( line(1:3)=='cir' ) then
        read(line(is:ie),*) xx, yy, rad
        na=na+1
        IL=xx-rad
        IH=xx+rad
        JL=yy-rad
        JH=yy+rad
        call CENOFGR(Ga,iext,jext,IL,IH,JL,JH,XC,YC)
        xa(na)=xc
        ya(na)=yc
        print '(i5,3i5,2f10.3)', na,nint(xx),nint(yy),nint(rad),xa(na),ya(na)
     end if
  end do
  
501 close(51)
  
  ! --- VICTIM FRAME --- 
  print *
  print *, '##### VICTIM    FRAME #####'
  print *, '  ID   IX   IY   W/2    Xc        Yc'
  open(52, file=vregs)
  
  nb=0
  do i=1, 999
     read(52, '(a70)', end=502) line
     is=index(line, '(')+1
     ie=index(line, ')')-1
     if ( line(1:3)=='box' ) then
        read(line(is:ie),*) xx, yy, wid, hei
        nb=nb+1
        IL=xx-wid/2
        IH=xx+wid/2
        JL=yy-hei/2
        JH=yy+hei/2
        call CENOFGR(Gb,iext,jext,IL,IH,JL,JH,XC,YC)
        xb(na)=xc
        yb(na)=yc
        print '(i5,3i5,2f10.3)', nb,nint(xx),nint(yy),nint(wid),xb(nb),yb(nb)
     else if ( line(1:3)=='cir' ) then
        read(line(is:ie),*) xx, yy, rad
        nb=nb+1
        IL=xx-rad
        IH=xx+rad
        JL=yy-rad
        JH=yy+rad
        call CENOFGR(Gb,iext,jext,IL,IH,JL,JH,XC,YC)
        xb(nb)=xc
        yb(nb)=yc
        print '(i5,3i5,2f10.3)', nb,nint(xx),nint(yy),nint(rad),xb(nb),yb(nb)
     end if
  end do
  
502  close(52)

  return
  
end SUBROUTINE RDREGS
