program mmprof
  
  ! Original version by M. Hamabe 1999-09-02 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-10-18 (for Fortran90)
  ! Updated by M. Hamabe  2007-10-23 (opninp)

  
  real, allocatable :: G(:,:)   
  character image*80, tabl*80, tabfile*80
  character TITLE*40, band*2, extend*30, aver*5, show*5, ok
  integer   im, irc
  character KIND(6)*8,YN, device*20
  character cline(1010)*80,blnk*40
  dimension PROF(1000),PAM(4),prbak(1000,4),NP(4)
  data blnk /'                                        '/
  data KIND /'  Maj(E)','  Maj(W)','  Min(E)','  Min(W)','  Major ','  Minor '/
  
  LOUT=21
  IFLG=-999                 ! flag for the window which is not opened yet
  device='/XWINDOW'         ! device for display/plot
  ipal=2                    ! default color palett
  IW1=IFLG                  ! wiondow-1 is not opened yet
  
  do j=1,1010
     cline(j)=blnk//blnk
  end do
  
  call opninp (1,im,0,image,title,iext,jext,irc)
  if ( irc/=0 ) go to 999
  
  call clargc (2, tabl, irc)
  if ( irc/=0 ) then
     print '(''Enter output profile-table name: '',$)'
     read *, tabl
  end if
  tabfile=extend(tabl,'prf')
  open (LOUT, file=tabfile,access='SEQUENTIAL')
  
  call GETKEYS(im,'BAND    ',band,irc)
  if ( irc/=0 ) then
     print '(''Enter color band (A2)     ===> '',$)'
     read '(a)', band
  end if
  print '(''     Band = '',a2)',  band
  
  call GETKEYE(im, 'CDELT1  ',PSIZE,irc)
  if ( irc/=0 ) call GETKEYE(im,'SECPPIX ',PSIZE,irc)
  psize=abs(psize)
  if ( psize<10/3600.0 ) psize=psize*3600.0
  if ( psize<0.001 .or. psize>10.0 ) irc=1
  if ( irc/=0 ) then
     print '(''Enter pixel size in unit of arcsec/pixel      ===> '',$)'
     read *, PSIZE
     irc=0
  end if
  print '(''     Pixel size ='',f6.3,''(arcsec)'')', PSIZE
  
  call clargr (3, CENTI, irc)
  if ( irc/=0 .or. CENTI<=0.0 ) then
     print '(''Enter x-coordinate of galaxy center (pixel) ===> '',$)'
     read *, CENTI
  end if
  call clargr (4, CENTJ, irc)
  if ( irc/=0 .or. CENTJ<=0.0 ) then
     print '(''Enter y-coordinate of galaxy center (pixel) ===> '',$)'
     read *, CENTJ
  end if
  print *
  print '(''galaxy center ('',f7.1,'','',f7.1,'')'')', centi,centj
  call clargr (5, PA0, irc)
  if ( irc/=0 ) then
     print '(''Enter position angle (degree; north to east) ===> '',$)'
     read *, PA0
  end if
  if ( PA0<0.0   ) PA0=PA0+180.0
  if ( PA0<0.0   ) PA0=PA0+180.0
  if ( PA0>=180.0 ) PA0=PA0-180.0
  pam(1)=PA0
  pam(2)=PA0+180.0
  if ( PA0>=90.0 ) then
     pam(3)=PA0- 90.0
     pam(4)=PA0+ 90.0
  else
     pam(3)=PA0+ 90.0
     pam(4)=PA0+270.0
  end if
  call clargr (6, radmax, irc)
  if ( irc/=0 ) then
     print '(''Enter maximum radius (arcsec) ===> '',$)'
     read *, radmax
  end if
  call clargc (7, aver, irc)
  if ( irc/=0 ) aver='yes'
  
  call GETKEYE(im, 'UNIT-MAG', sky, irc)
123 if ( irc/=0 ) then
     print '(''Enter unit magnitude (sky, if Isky=1)  ===> '',$)'
     read *, sky
  end if
  print '(''pixel value = 1  <===> '',f7.3,'' mag arcsec**(-2)'')', sky
  if ( sky<10.0 .or. sky>30.0 ) then
     print '('' OK? (<y>/n) ===> '',$)'
     read '(a)', ok
     if ( ok=='n' ) then
        irc=1
        go to 123
     end if
  end if
  irc=0
  
  allocate( G(iext, jext) )
  call MATRD(im,G,IEXT,JEXT,irc)
  call clargc (11, show, irc)
  if ( irc/=0 ) show='yes'
  irc=0
  
  !     *** DISPLAY IMAGE ***
  if ( show=='yes' ) then
     call SPG_OPN(IW1,IFLG,device)
     if ( iext>=(jext*1.75) ) then
        width=7.0
        ratio=float(jext)/float(iext)*1.25
     else if ( iext>=jext .or. jext<(iext*1.2) ) then
        width=5.0
        ratio=float(jext)/float(iext)*1.2
     else
        hight=8.0
        ratio=float(jext)/float(iext)*1.1
        width=hight/ratio
     end if
     
     !     Set up graphics device to display image.
     !        call test(g,iext,jext)
     call PGPAP(width, ratio) ! set the size and aspect
     call PGSVP(0.0,1.0,0.0,1.0)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     IS=1
     ie=iext/6
     JS=1
     JE=JEXT/6
     FACT=3.0
     NCYCLE=2
     
     call STATRJ(G,IEXT,JEXT,IS,IE,JS,JE,FACT,NCYCLE,GMAX,GMIN,GMEAN,GSD,NREJ,KRET)
     rmin=gmean-gsd
     rmax=gmax+200*gsd
     
     if ( rmin<=0.0 ) rmin=0.002
     
777  print *, 'displaying the image ...'
     print '(''z1='',f12.3,''  z2='',F12.3)', rmin, rmax
     call SPG_DSP(G,IEXT,JEXT,TITLE,RMIN,RMAX,IPAL,IW,1,1,iext,jext)
     
     print '(''Is display level OK? '',$)'
     read  '(a)', yn
     if ( yn=='n' ) then
        print '(''z1,z2 = '',$)'
        read *, rmin,rmax
        goto 777
     end if
  end if
  
  !     *** DEFINE PROFILE PARAMETERS ***
  print *
  print '(''Image title: '',A40)', TITLE
  print *
  print '(''Is the title ok ? (<y>/n) ===> '',$)'
  read  '(A1)', YN
  if (YN=='n') then
     print *, '       ----+----+----+----+----+----+----+----+'
     print '(''Title: '',$)'
     read  '(A40)', TITLE
  ENDIF
  call clargr (8, apsec, irc)
  if ( irc/=0 .or. apsec<=0.0 ) then
     print '(''Enter aperture (arcsec) ===> '',$)'
     read  *, apsec
  end if
  call clargr (9, fan, irc)
  if ( irc/=0 .or. fan<0.0 ) then
     print '(''Enter fan angle (degree) ===> '',$)'
     read  *, fan
  end if
  call clargr (10, pitsec, irc)
  if ( irc/=0 .or. pitsec<=0.0 ) then
     print '(''Enter pitch (arcsec) ===> '',$)'
     read  *, pitsec
  end if
  print *
  print '(5X,''Aperture  = '',f6.3,'' arcsec'')', APSEC
  print '(5X,''Fan angle = '',f6.3,'' degree'')', FAN
  print '(5X,''Pitch     = '',f6.3,'' arcsec'')', PITSEC
  print '(5X,''*1 pixel  = '',f6.3,'' arcsec'')', PSIZE
  print  *
  NpMAX=2000
  if ( radmax>0.0 ) NpMAX=radmax/pitsec
  
  !     *** write PARAMETER IN OUTPUT FILE ***
  write(LOUT,'(''Image title: '',A40)') TITLE
  write(LOUT,'(''Band = '',a2,5x, &
       &       ''Sky ='',F6.2,'' mag/square-arcsec'',5x, &
       &       ''Pixel size ='',F5.2,''"'')') BAND,SKY,PSIZE
  write(LOUT,'(''Sample Pitch ='',f6.2,''"'', &
       &       ''    Aperture at start ='',f5.2,''"'', &
       &       ''    Fan angle ='',f5.2,'' degree'')') PITSEC,APSEC,FAN
  
  !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
  AP   =APSEC/PSIZE
  PITCH=PITSEC/PSIZE
  !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
  
  NPROF=0
  NMAX =0
  
  !     *** SELECT MODE ***
  write(cline(8)(1:24),'(a24)') '  R(sec)   Log R  R^0.25'
1000 continue
  
  !     *** DETERMINE START POINT ***
  SI=CENTI
  SJ=CENTJ
  if(SI< 1.0          ) go to 9000
  if(SI>real(IEXT)) go to 9000
  if(SJ< 1.0          ) go to 9000
  if(SJ>real(JEXT)) go to 9000
  if (show=='yes') call PGCIRC(SI,SJ,2.0)
  
  !     *** SELECT MODE ***
1300 continue
  PA0=pam(nprof+1)
  if( PA0<  0.0 ) go to 1300
  if( PA0>=360.0 ) go to 1300
  if( PA<=180.0 ) PA=180.0 - PA0
  if( PA>180.0 ) PA=540.0 - PA0
  EI=-1.0
  EJ=-1.0
  
  !     *** CREATE PROFILE ***
  NPROF=NPROF+1
  call CRPRFL(G,IEXT,JEXT,SI,SJ,PA,NpMAX,AP,FAN,PITCH, &
       &      PROF,NP(NPROF),show)
  print '(''from ('',f6.1,'','',f6.1,'')   '', i5,'' points'')', &
       & SI, SJ, NP(NPROF)
  
  !     *** write TO OUTPUT FILE ***
  ks=(nprof-1)*8+25
  ke=(nprof-1)*8+32
  write(cline(1)(17:24),'(a8)') 'N_data  '
  write(cline(1)(ks:ke),'(i8)') NP(NPROF)
  write(cline(2)(17:24),'(a8)') 'X_start '
  write(cline(2)(ks:ke),'(f8.2)') SI
  write(cline(3)(17:24),'(a8)') 'Y_start '
  write(cline(3)(ks:ke),'(f8.2)') SJ
  write(cline(4)(17:24),'(a8)') 'X_end   '
  write(cline(4)(ks:ke),'(f8.2)') EI
  write(cline(5)(17:24),'(a8)') 'Y_end   '
  write(cline(5)(ks:ke),'(f8.2)') EJ
  if ( PA<=180.0 ) PA0=180.0-PA
  if ( PA>180.0 ) PA0=540.0-PA 
  write(cline(6)(17:24),'(a8)') 'Pos.Ang.'
  write(cline(6)(ks:ke),'(f8.2)') PA0
  write(cline(7)(17:24),'(a8)') 'Mode    '
  write(cline(7)(ks:ke),'(a8)') '   P.A. '
  write(cline(8)(ks:ke),'(a8)') KIND(nprof)
  
  do j=1, NP(NPROF)
     rsec= pitsec*(j-1)
     rlog=-5.0
     if ( rsec>0.0 ) rlog=log10(rsec)
     rq=rsec**(0.25)
     adum= PROF(j)
     prbak(j,nprof)=adum
     if ( adum>0.0 ) then
        amag=-2.5*log10(adum)+sky
     else
        amag=999.99
     end if
     write(cline(j+8)( 1:24),'(3f8.3)') rsec, rlog, rq
     write(cline(j+8)(ks:ke),'(3f8.3)') amag
  end do
  if ( NP(NPROF)>nmax ) nmax=NP(NPROF)
  
  if (nprof==4) goto 9000
  go to 1000
  
9000 continue
  !     calcurate mean majo- and minor-axis profiles
  if (aver=='yes' ) then
     nmaj=min(NP(1),NP(2))
     write(cline(1)(57:64),'(i8)') Nmaj
     write(cline(8)(57:64),'(a8)') KIND(5)
     do j=1,nmaj
        ave=(prbak(j,1)+prbak(j,2))*0.5
        if ( ave>0.0 ) then
           amag=-2.5*log10(ave)+sky
        else
           amag=999.99
        end if
        write(cline(j+8)(57:64),'(3f8.3)') amag
     end do
     nmaj=min(NP(3),NP(4))
     write(cline(1)(65:72),'(i8)') Nmaj
     write(cline(8)(65:72),'(a8)') KIND(6)
     do j=1,nmaj
        ave=(prbak(j,3)+prbak(j,4))*0.5
        if ( ave>0.0 ) then
           amag=-2.5*log10(ave)+sky
        else
           amag=999.99
        end if
        write(cline(j+8)(65:72),'(3f8.3)') amag
     end do
  end if
  
  do j=1,nmax+10
     write(LOUT,'(a)') cline(j)
  end do
  
  if ( show=='yes' ) then
     print '(''Hit Return-key'',$)'
     read  '(a)', yn
  end if
  
  STOP
  
999 call PUTEMSG(irc)
  deallocate(G)
  
  stop
end program mmprof

!----------------------------------------------------------------------
SUBROUTINE CRPRFL(G,IEXT,JEXT,SI,SJ,PA,NpMAX, &
     &            AP,FAN,PITCH,PROF,NP,show)
  
  character  show*5
  dimension G(IEXT,JEXT),PROF(2000),WX(10),WY(10),WZ(10)
  
  RMAX=10000.0
  
  P=PA /180.0*3.14159265
  F=FAN/180.0*3.14159265
  
  do N=1,NpMAX
     R=real(N-1)*PITCH
     if(R>RMAX)         go to 1000
     X=SI-R*SIN(P)
     Y=SJ-R*COS(P)
     A=(AP+R*F)*0.5
     !CCCCC   B=int(A)+1 CCCCCCCC S.OKAMURA (88/07/16) CCCCCCCCCCCCC
     B=int(A)+2
     if(X-B<     1.0  ) go to 1000
     if(X+B>real(IEXT)) go to 1000
     if(Y-B<     1.0  ) go to 1000
     if(Y+B>real(JEXT)) go to 1000
     if (show=='yes')  call PGCIRC(X,Y,A)
     
     if (A<=0.5) then
        IX1=X
        IX2=X+1
        IY1=Y
        IY2=Y+1
        V1=(G(IX2,IY1)-G(IX1,IY1))*(X-real(IX1))+G(IX1,IY1)
        V2=(G(IX2,IY2)-G(IX1,IY2))*(X-real(IX1))+G(IX1,IY2)
        PROF(N)=(V2-V1)*(Y-real(IY1))+V1
     else
        call CINTEG(G,IEXT,JEXT,X,Y,A,1,0,DUM,KDUM,VAL,PIX,WX,WY,WZ,10,KREC)
        if (KREC/=0) then
           print *, '*** CODE = ',KREC
        end if
        if(PIX<=1.0E-5) then
           PROF(N)=0.0
        else
           PROF(N)=VAL/PIX
        end if
     end if
  end DO
  N=N+1
  
1000 continue
  NP=N-1
  
  return
end SUBROUTINE CRPRFL

!----------------------------------------------------------------------
SUBROUTINE PROANG(SI,SJ,EI,EJ,PA)
  
  !     *** DETERMINE POSITION ANGLE FROM TWO POINTS ***
  
  PI=3.14159265
  
  if(EJ<SJ) then
     PA=ATAN((EI-SI)/(EJ-SJ))
     PA=PA*180.0/PI
     if(PA<0.0) PA=PA+360.0
  else if(EJ>SJ) then
     PA=ATAN((EI-SI)/real(EJ-SJ))
     PA=PA*180.0/PI+180.0
  else
     if(EI>SI) then
        PA=270.0
     else if(EI<SI) then
        PA= 90.0
     else
        print *, '### ERROR ###'
        PA=  0.0
     end if
  end if
  
  return
end SUBROUTINE PROANG
