#
#		Update: M.Hamabe	1996-09-30
#		Update: M.Hamabe	2003-06-28 (support @-files)
#	
procedure  skysub (srcimages, outimages,order)
	
file	srcimages	{prompt='input  images  (object + sky)'}
file	outimages	{prompt='output images (sky-subtracted)'}
int	order		{0,prompt='(maximum) order of polynomial (0-5)'}
bool	checkorder	{'yes',prompt='check several order?'}
real    rrange		{1.0,prompt='display range (% of sky) of residual matrix'}
int     iteration	{5,prompt='number of iterations in sky-fitting'}
bool    interactive	{'yes',prompt='define rejection areas interactively?'}
file    areas		{'skypar',prompt='parameter files for rejection areas'}
real	cutoff		{32767.0,prompt='cut-off value to remove cosmic-ray-events'}
bool    savereg		{'yes',prompt='save ignored regions in the data header?'}
int     offset          {1,prompt='IRAF file number offset'}
bool    reintrct	{'yes',prompt='define rejection area interactively?'}
file	rfile		{'ds9.reg',prompt='ds9 reg-file for rejection'}

struct  *oldlist, *newlist

begin	
	file    srcimage,  outimage,  newhead
        file    temp1, temp2
        int     oldcount,  newcount,  seqno

# --- Expand metacharacters (or @-files) in each input parameter into a template file.
   temp1 = mktemp ("skysub.tmp")
   files (srcimages, > temp1)
   oldlist = temp1
   temp2 = mktemp ("skysub.tmp")
   files (outimages, > temp2)
   newlist = temp2

# --- Count specified old and new images.
   oldcount  = 0
   while (fscan (oldlist,  srcimage ) != EOF) {
       oldcount  += 1
   }
   oldlist  = temp1        # rewind oldlist
   newcount = 0
   while (fscan (newlist, outimage) != EOF) {
       newcount += 1
   }
   newlist = temp2         # rewind newlist

# --- Main

   task $skysub1=("$" // osfn("spiral$bin/") // "skysub.e $(*)" )
   if (newcount == oldcount) {
       while (fscan (oldlist, srcimage) !=EOF && \
              fscan (newlist, outimage) !=EOF    ) {
          print ("skysub "//srcimage//" --->  "//outimage)
          skysub1 (srcimage,outimage,order,checkorder,rrange, \
                   iteration,cutoff,interactive,areas,savereg,reintrct,rfile)
      }
   }
   else if (newcount == 1) {
      newhead = outimage
      seqno = offset
      while (fscan (oldlist,  srcimage ) != EOF) {
         outimage = newhead // "000" + seqno
         print ("skysub "//srcimage//" --->  "//outimage)
         skysub1 (srcimage,outimage,order,checkorder,rrange, \
                  iteration,cutoff,interactive,areas,savereg,reintrct,rfile)
         seqno += 1
     }
   }
     else print ("Error: The number of srcimages and outimages are not the same.")
     oldlist = ""
     newlist = ""
     del ("skysub.tmp*", verify-, >& "dev$null")
end
