program sky_sub
  
  ! Original version by M. Hamabe 2004-05-18 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-10-09 (for Fortran90)
  ! Updated by M. Hamabe  2007-10-23 (opninp)
  ! Updated by H. Shimizu 2007-11-20 (RDDSREG)

  parameter  (maxsub=1024)
  real, allocatable :: G(:,:), MAP(:,:)
  character :: title*40
  character :: image1*80, image2*80, outfile*80
  character :: cttl*8, cpn, yn, device*20, cdum
  character :: comsky*50, checko*5, interact*5, savereg*5, skypar*80
  character :: cio(100), reintrct*5, rfile*80
  real(8)   :: coef(21), cff(21,6)
  integer   :: im, irc, bitpix, box(100), boy(100), wid(100), heit(100)
  real(4)   :: SKY(maxsub,maxsub), RES(maxsub,maxsub)
  integer   :: IRS(100),IRE(100),JRS(100),JRE(100),elx(100),ely(100)
  real(4)   :: X(maxsub*maxsub),Y(maxsub*maxsub),Z(maxsub*maxsub)
  real(4)   :: tr(6)
  data      tr/0.0, 1.0, 0.0, 0.0, 0.0, 1.0/
  
  !     *** SET LOGICAL UNIT NUMBER AND INITIALIZE ***
  LIN =11
  nlp =16
  IFLG=-999                 ! flag for the window which is not opened yet
  device='/XWINDOW'         ! device for display/plot
  ipal=0                    ! default color palett
  iw1=IFLG                  ! wiondow-1 is not opened yet
  iw2=IFLG                  ! wiondow-2 is not opened yet
  
  elx=0

  !     *** Read matrix ***
  call opninp (1,im,0,image1,title,iext,jext,irc)
  if (irc/=0 ) go to 999
  
  call getclpar(image1,image2,kfit,checko,rrange,limitr,HIGHB,&
       &  interact,skypar,savereg,nlp,outfile,reintrct,rfile)
  irc=0
  call GETKEYJ(im,'BLANK',iblank,irc)
  if ( irc /= 0 ) then
     call GETKEYJ(im,'IGNRVAL',iblank,irc)
     if ( irc /= 0 ) then
        irc=0
        blank=-100000.0      !-999999.0
        print *, 'BLANK is not defined'
     else
        print *, 'IGNRVAL is assumed to be BLANK'
        blank=iblank
     end if
  else
     blank=iblank
  end if
  print '('' ---> BLANK is assumed to '',G15.7)', blank
  allocate( G(iext, jext) )   ! ptr1=malloc(iext*jext*4)
  call MATRD(im,G,iext,jext,irc)
  if ( irc /= 0 ) go to 999

  if ( reintrct=='yes' ) then
     
     !     *** DISPLAY INPUT FRAME ***
     call SPG_OPN(iw1,IFLG,device)
     call DEF_WSIZE(iext,jext,width,hight,ratio)
     
     !     Set up graphics device to display image.
     call PGPAP(width, ratio)  ! set the size and aspect
     call PGSVP(0.0,1.0,0.0,1.0)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     
     IS=1
     ie=iext !/4     !!  ie=iext/6
     JS=1
     JE=jext !/4     !!  JE=jext/6
     FACT=3.0
     NCYCLE=2
     call STATRJ(G,iext,jext,IS,IE,JS,JE,FACT,NCYCLE,GMAX,GMIN,GMEAN,GSD, &
          & NREJ,KRET)
     print *, 'mean, sd=', gmean, gsd
     rmin=gmean-gsd
     if( rmin < 0 ) rmin=0
     rmax=gmean+gsd/2
     
777  print *, 'displaying original image in linear scale ...'
     print '(''z1='',f12.3,''  z2='',F12.3)', rmin, rmax
     
     TITLE='Original Density Matrix'
     call SPG_DSP(G,iext,jext,TITLE,rmin,rmax,ipal,iw,1,1,iext,jext)
     
     if( reintrct=='yes' ) then
        print '(''Is display level OK? '',$)'
        read '(a)', yn
        if ( yn == 'n' ) then
           !!     print '(''color/posi/nega? (c/p/<n>) ===> '',$)'
           !!     read '(a)', cpn
           ipal=0
           !!     if ( cpn == 'c' ) ipal=2
           !!     if ( cpn == 'p' ) ipal=1
           print '(''z1,z2 = '',$)'
           read *, rmin,rmax
           goto 777
        end if
     end if
  end if
  
  !     *** SET REJECTION AREA ***
  if( reintrct=='no' ) call RDDSREG(rfile,iext,jext,IRS,JRS,IRE,JRE,CIO,NREJ,elx,ely,100)
  if (reintrct=='yes' .and. interact=='yes') call CRDREGN(iext,jext,IRS,JRS,IRE,JRE,CIO,NREJ,100)
  if ( reintrct=='yes' .and. interact=='no' ) then
     open(LIN,file=skypar,access='SEQUENTIAL')
     nrej=0
     do i=1,100
        read (LIN,'(a1,4x,4i6)',end=529) cio(i),IRS(i),IRE(i),JRS(i),JRE(i)
        nrej=nrej+1
        x1=IRS(i)
        x2=IRE(i)
        y1=JRS(i)
        y2=JRE(i)
        if ( y2 >= 0.0 ) then           ! shape is a rectangle
           !           call SPG_BOX2(x1,x2,y1,y2,color,lwidth,style,lwidth_h)
           if ( cio(i) == 'i' ) then
              call SPG_BOX2(x1,x2,y1,y2,2,6,3,1)
           else
              call SPG_BOX2(x1,x2,y1,y2,3,6,2,1)
           end if
        else                            ! shape is a circle
           if ( cio(i) == 'i' ) then
              call SPG_CIR2(x1,x2,y1,   2,6,3,1)
           else
              call SPG_CIR2(x1,x2,y1,   3,6,2,1)
           end if
        endif
     end do
  end if
529 continue
  if ( interact /= 'yes' .and. reintrct=='yes' ) then
     print *
     print *, '*** type return-key'
     read '(a)', cdum
     print *
  end if
  
  call PGCLOS
  iw1=IFLG
  
  !     *** CHECK REJECTION AREAS ***
  print *, '  ----------------- Region to be rejected ---------------------'
  print *, '     in/out  Box   IS  -  IE,   JS  -  JE'
  print *, '  or in/out  Box  ( Xc ,  Yc ),   Width,     Height,    Angle'
  print *, '  or in/out  Cir  ( Xc ,  Yc ),   Radius'
  print *, '  or in/out  Ell  ( Xc ,  Yc ),   Lradius,   Sradius,   Angle'
  print *, '  -------------------------------------------------------------'
  do i=1,nrej
     if ( JRE(i) >= 0 ) then
        if ( elx(i) == 0 ) then
           print '(a1,5x,'' Box '',i4,'' - '',i4,'', '',i4,'' - '',i4,'' '')', &
                & cio(i),IRS(i),IRE(i),JRS(i),JRE(i)
        else
           box(i)=(IRE(i)-IRS(i))/2+IRS(i)
           boy(i)=(JRE(i)-JRS(i))/2+JRS(i)
           wid(i)=IRE(i)-IRS(i)
           heit(i)=JRE(i)-JRS(i)
        print '(a1,5x,'' Box '', '' ('',i4,'', '',i4,'' ), '',i4,'', '',i4, &
             '', '',i4)', cio(i),box(i),boy(i),wid(i),heit(i),elx(i)
        end if
     else if ( JRE(i) == -999 ) then
        print '(a1,5x,'' Cir '', '' ('',i4,'', '',i4,'' ), '',i4)', &
             & cio(i),IRS(i),IRE(i),JRS(i)
     else
        print '(a1,5x,'' Ell '', '' ('',i4,'', '',i4,'' ), '', i4, '', '', &
             & i4, '', '',i4)',cio(i),elx(i),ely(i),IRS(i),IRE(i),JRS(i)
     end if
  end do
  print *, '  -------------------------------------------------------------'
  if ( reintrct == 'yes' .and. interact == 'yes' ) then
     open(LIN,file=skypar,access='SEQUENTIAL')
     do i=1,nrej
        write(LIN,'(a1,4x,4i6)') cio(i),IRS(i),IRE(i),JRS(i),JRE(i)
     end do
     print *, '%%%%% Parameters were saved in "skypar" '
  end if
  nrej0=nrej
  
  !     *** CREATE SKY MATRIX ***
  K1=(iext-1)/maxsub+1
  K2=(jext-1)/maxsub+1
  KSKY=MAX(K1,K2)
  if ( ksky <= 0 ) ksky=1
  ISKY=iext/KSKY
  JSKY=jext/KSKY
  call REDUCEB(G,iext,jext,SKY,ISKY,JSKY,KSKY,BLANK,irc)
!!!!!!!!!!!!1987-09-06 !!!!!!!!!!!!!
  IOFF=ISKY/2
  JOFF=JSKY/2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  !-------Check various orders ---------
  if ( checko(1:3) == 'yes' ) then
     kfit00=kfit
     width=9.0*(kfit+1)/4.
     ratio=1/real(kfit+1)
     if ( kfit > 3 )  then
        width=7.0
        ratio=0.6
     end if
     call SPG_OPN(iw1,IFLG,DEVICE)
     call PGPAP(width,ratio*1.2)
     call PGSVP(0.05,0.95,0.1,0.8)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     if ( kfit <= 3 ) then
        call PGSUBP(kfit+1,1)
     else
        call PGSUBP(3,2)
     end if

     RANGE = rrange * 0.01
     print *
     print *, '--- Display residual of sky-fitting ---'
     do jf=0,kfit
        print '(''%%%%%% Order ='',i2,'' %%%%%'')', jf
        if ( nlp /= 0 ) write(nlp,'(/''%%%%%% Order ='',i2,'' %%%%%'')') jf
        allocate( MAP(ISKY, JSKY) )   ! ptr2=malloc(ISKY*JSKY)
        call SkfitC(SKY,ISKY,JSKY,KSKY,MAP,IRS,IRE,JRS,JRE,elx,ely,box,boy, &
             &     wid,heit,cio,NREJ,coef,jf,nlp,X,Y,Z,IOFF,JOFF,HIGHB,blank,limitr)
        call RESMTC(SKY,ISKY,JSKY,coef,jf,RES,IOFF,JOFF)
        if ( kfit <= 3 ) then
           call PGPANL(jf+1,1)
        else
           jfp1=jf+1
           if ( jfp1 <= 3 ) then
              ipn=jfp1
              jpn=1
           else
              ipn=jfp1-3
              jpn=2
           end if
           call PGPANL(ipn,jpn)
        end if
        call PGWNAD(0.5,real(isky)+0.5,0.5,real(Jsky)+0.5)
        call PGSCI(1)
        call SPG_PLT(-1)
        call PGIMAG(res,ISKY,JSKY,1,ISKY,1,JSKY,-range,range,tr)
        cttl='order= '
        write(cttl(7:7),'(i1)') jf
        call PGSCH(3.)
        call PGTEXT(real(isky)/10.0,real(jsky)*1.05,cttl)
        call PGSCH(1.)
        deallocate(MAP)   ! call free(ptr2)
        do ii=1,21
           cff(ii,jf+1)=coef(ii)
        end do
     end do
     
     !------Calcurate adopted order --------
     print *
     print '(''Enter order of polynomial (0-'',i1,'') ===> '',$)', kfit00
     read *, kfit
     if ( kfit < 0 .or. kfit > kfit00 ) then
        print '(''### order must be 0-'',i1,'' ###'')', kfit00
        print *, 'ORDER = ',kfit00
        kfit=kfit00
     end if
     if ( nlp /= 0 ) write(nlp,'(//'' ******* Adopted Order ='',i2)') kfit
     call PGCLOS
     iw1=IFLG
  end if
  
  !     *** SKY BACKGROUND FITTING BY 2-D POLYNOMIALS ***
  print *
  print *, 'Sky background is being fitted ...'
  print *
  print *, '------ Order of 2D polynomial = ',kfit,'------'
  if ( checko(1:3) == 'yes' ) then
     do ii=1,21
        coef(ii)=cff(ii,kfit+1)
     end do
  else
     call SPG_OPN(iw1,IFLG,DEVICE)
     call PGPAP(8.0,0.6)
     call PGSVP(0.05,0.95,0.1,0.8)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     call PGSUBP(2,1)
     RANGE=rrange*0.01
     print *
     print *, '--- Display residual of sky-fitting ---'
     allocate( MAP(ISKY, JSKY) )   ! ptr2=malloc(ISKY*JSKY)
     call SkfitC(SKY,ISKY,JSKY,KSKY,MAP,IRS,IRE,JRS,JRE,elx,ely,box,boy, &
          &     wid,heit,cio,NREJ,coef,kfit,nlp,X,Y,Z,IOFF,JOFF,HIGHB,blank,limitr)
     call RESMTC(SKY,ISKY,JSKY,coef,kfit,RES,IOFF,JOFF)
     call PGPANL(1,1)
     call PGWNAD(0.5,real(isky)+0.5,0.5,real(Jsky)+0.5)
     call PGSCI(1)
     call SPG_PLT(-1)
     call PGIMAG(RES,ISKY,JSKY,1,ISKY,1,JSKY,-range,range,tr)
     TITLE='Residual Matrix'
     call PGSCH(3.)
     call PGTEXT(real(isky)/10.0,real(jsky)*1.05,TITLE)
     call PGSCH(1.)
     call MAPREJ(MAP,RES,ISKY,JSKY)
     call PGPANL(2,1)
     call PGWNAD(0.5,real(isky)+0.5,0.5,real(Jsky)+0.5)
     call PGSCI(1)
     call SPG_PLT(-1)
     call PGIMAG(RES,ISKY,JSKY,1,ISKY,1,JSKY,-range,range,tr)
     TITLE='Rejected Pixels'
     call PGSCH(3.)
     call PGTEXT(real(isky)/10.0,real(jsky)*1.05,TITLE)
     call PGSCH(1.)
     deallocate(MAP)   ! call free(ptr2)
     print *
     print *,'type return-key'
     read '(a)', cdum
     print *
     call PGCLOS
     iw1=IFLG
  end if
  
  !     *** SKY SUBTRACTION ***
  print *
  print *, 'Sky-subtraction is being done ...'
  call skysb(G,iext,jext,ksky,coef,kfit,ioff,joff,blank,skyval)
  call SPG_OPN(iw1,IFLG,device)
  call DEF_WSIZE(iext,jext,width,hight,ratio)
  
  !     Set up graphics device to display image.
  call PGPAP(width, ratio)  ! set the size and aspect
  call PGSVP(0.0,1.0,0.0,1.0)
  call PGSWIN(0.0,1.0,0.0,1.0)
  call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
  call PGSFS(2)
  ipal=1
  
  IS=1
  ie=iext!/6
  JS=1
  JE=jext!/6
  FACT=3.0
  NCYCLE=2
  call STATRJ(G,iext,jext,IS,IE,JS,JE,FACT,NCYCLE,GMAX,GMIN,GMEAN,GSD,NREJ,KRET)      
  print *, 'mean, sd=', gmean, gsd
  rmin=gmean-gsd
  rmax=gmean+gsd*3
  
888 print *, 'displaying sky-subtracted image ....'
  print '(''z1='',f12.3,''  z2='',F12.3)', rmin, rmax
  
  TITLE='Sky-subtracted Relative Intensity Matrix'
  call SPG_DSP(G,iext,jext,TITLE,rmin,rmax,ipal,iw,1,1,iext,jext)
  print '(''Is display level OK? '',$)'
  read '(a)', yn
  if ( yn == 'n' ) then
     !     print '(''color/posi/nega? (<c>/p/n) ===> '',$)'
     !     read '(a)', cpn
     !     if ( cpn == 'n') then
     !        ipal=0
     !     else if ( cpn == 'p' ) then
     ipal=1
     !     else
     !        ipal=2
     !     end if
     print '(''z1,z2 = '',$)'
     read *, rmin,rmax
     goto 888
  end if
  
  print '(''OK? '',$)'
  read '(a)', yn
  if ( yn == 'n' ) then
     print *, 'sky-subtraction will not be executed.'
     call PGend
     call system('\\rm '//outfile)
     stop
  end if
  call PGCLOS
  
  print *, 'Sky-subtracted matrix is being created ...'
  bitpix=-32
  call IMGCOPY(im,nim,bitpix,image2,irc)
  if ( irc /= 0 ) go to 999
  call FCLOSE(im,irc)
  if ( irc /= 0 ) go to 999
  
  call MATWT (nim,G,iext,jext,irc)
  if ( irc /= 0 ) go to 999

  comsky='SKY-FITTING ORDER =                '
  write(comsky(20:21),'(i2)') kfit
  call adhstry(nim,'SKYSUB',6,comsky,irc)
  comsky='SOURCE: '//image1
  call adhstry(nim,'SKYSUB',0,comsky,irc)
  if ( savereg == 'yes' ) then
     comsky='Rejected regions for sky-fitting'
     call adhstry(nim,'SKYSUB',0,comsky,irc)
     do i=1, nrej0
        if ( JRE(i) /= -999 ) then
           if ( cio(i) == 'i' ) then
              write(comsky,'(''In:   IS ='',i5,'', IE ='',i5, &
                   &             '', JS ='',i5,'', JE ='',i5)') &
                   &        IRS(i),IRE(i),JRS(i),JRE(i)
           else
              write(comsky,'(''Out:  IS ='',i5,'', IE ='',i5, &
                   &             '', JS ='',i5,'', JE ='',i5)') &
                   &        IRS(i),IRE(i),JRS(i),JRE(i)
           end if
        else
           if ( cio(i) == 'i' ) then
              write(comsky,'(''In:   IC ='',i5,'', JC ='',i5, &
                   &                 '',  R ='',i5)') IRS(i),IRE(i),JRS(i)
           else
              write(comsky,'(''Out:  IC ='',i5,'', JC ='',i5, &
                   &                 '',  R ='',i5)') IRS(i),IRE(i),JRS(i)
           end if
        endif
        call adhstry(nim,'SKYSUB',0,comsky,irc)
     end do
  end if
  
  comsky='MEAN OF SKY; JUST SUBTARCTED'
  call FTPKYF(nim,'MEAN-SKY',skyval,4,comsky,irc)
  if ( irc /= 0 ) go to 999
  call FCLOSE(nim,irc)
  if ( irc /= 0 ) go to 999
  
  close (nlp)
  
  deallocate(G)   ! call free(ptr1)
  call PGend
  STOP
  
999 call PUTEMSG(irc)
  deallocate(G)   ! call free(ptr1)
  call PGend

  stop
  
end program sky_sub

!----------------------------------------------------------------------
SUBROUTINE SkfitC(SKY,ISKY,JSKY,KSKY,MAP,IRS,IRE,JRS,JRE,elx,ely,box,boy, &
     &     wid,heit,cio,NREJ,coef,kfit,nlp,X,Y,Z,IOFF,JOFF,HIGHB,blank,limitr)
  
  !     *** SKY FITTING ***
  !     if nlp=0 then NO-PRINT
  
  character :: MAP(ISKY,JSKY),cio(nrej)
  real(8)   :: coef(21),XX,YY,ZZ
  real(4)   :: SKY(ISKY,JSKY)
  integer   :: IRS(NREJ),IRE(NREJ),JRS(NREJ),JRE(NREJ),elx(NREJ),ely(NREJ)
  integer   :: box(NREJ),boy(NREJ),wid(NREJ),heit(NREJ)
  real(4)   :: X(ISKY*JSKY),Y(ISKY*JSKY),Z(ISKY*JSKY)
!!!!!!!!!!!!1989-07-14 !!!!!!!! BY S.OKAMURA FOR TEST
  real(4)   :: FSD(5)
  integer   :: IJR(5)
  DATA FSD/2.0, 2.0, 2.0, 2.0, 1.0/
  DATA IJR/3, 2, 1, 0, 0/
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PI=3.14159

  !     *** INITIALIZE REJECTION MATRIX ***
  do J=1,JSKY
     do I=1,ISKY
        sdum =SKY(I,J)
        if ( sdum < HIGHB .and.  sdum > blank ) then
           MAP(I,J)='O'
        else
           MAP(I,J)=' '
        end if
     end do
  end do
  
  !     *** SET REJECTION MATRIX ***
  if ( nlp /= 0 ) then
     write(nlp,*)
     write(nlp,'('' --- Sky Background Fitting --- (ITR='',I2,'')'')') limitr
     write(nlp,'(16X,''Ignored Region(s)'')')
  end if
  do N=1,NREJ
     if ( JRE(N) >= 1 ) then     ! shape of the region is a box
        IS=MAX(   1,(IRS(N)-1)/KSKY+1)
        IE=MIN(ISKY,(IRE(N)-1)/KSKY+1)
        JS=MAX(   1,(JRS(N)-1)/KSKY+1)
        JE=MIN(JSKY,(JRE(N)-1)/KSKY+1)
        if (nlp /= 0) then
           if (elx(N) == 0) then
              write(nlp,'(5x,''BOX    LB = ('',i5,'','',i5, &
                   &           '')  -  RT = ('',i5,'','',i5,'')'')') & 
                   &            IRS(N),JRS(N),IRE(N),JRE(N)
           else
              write(nlp,'(5x,''BOX (Xc,Yc) = ('',i5,'','',i5,''),   W ='',i5, &
                   &           ''   H ='',i5,''   A ='',i5)') &
                   &           box(N),boy(N),wid(N),heit(N),elx(N)
           end if
        end if
        if ( cio(n) == 'i' ) then
           if ( elx(N)/=0 .and. elx(N)/=90 .and. elx(N)/=180 .and. elx(N)/=270 ) then
              ang=REAL(elx(N))*PI/180.0
              if ( IRS(N) < 1 ) IS=(IRS(N)-1)/KSKY+1
              if ( IRE(N) > isky ) IE=(IRE(N)-1)/KSKY+1
              if ( JRS(N) < 1 ) JS=(JRS(N)-1)/KSKY+1
              if ( JRE(N) > jsky ) JE=(JRE(N)-1)/KSKY+1
              brx=(IE-IS)/2+IS
              bry=(JE-JS)/2+JS
              do J=JS,JE
                 do I=IS,IE
                    bx=aint((I-brx)*cos(-ang)+(J-bry)*sin(-ang)+brx)
                    by=aint(-(I-brx)*sin(-ang)+(J-bry)*cos(-ang)+bry)
                    !!    ##   calculate each vertex   ##
                    if ( J==JS .and. I==IS ) then
                       ssbx=bx
                       ssby=by
                    else if ( J==JS .and. I==IE ) then
                       sebx=bx
                       seby=by
                    else if ( J==JE .and. I==IS ) then
                       esbx=bx
                       esby=by
                    else if ( J==JE .and. I==IE ) then
                       eebx=bx
                       eeby=by
                    end if
                 end do
              end do
              do J=1, jsky
                 do I=1,isky
                    !!    ##   calculate each line   ## 
                    L1=(ssby-seby)/(ssbx-sebx)*I+ssby-ssbx*(ssby-seby)/(ssbx-sebx)
                    L2=(esby-ssby)/(esbx-ssbx)*I+esby-esbx*(esby-ssby)/(esbx-ssbx)
                    L3=(esby-eeby)/(esbx-eebx)*I+esby-esbx*(esby-eeby)/(esbx-eebx)
                    L4=(eeby-seby)/(eebx-sebx)*I+eeby-eebx*(eeby-seby)/(eebx-sebx)
                    if ( elx(N) > 0 .and. elx(N) < 90 ) then
                       if ( J>L1 .and. J>L2 .and. J<L3 .and. J<L4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 90 .and. elx(N) < 180 ) then
                       if ( J<L1 .and. J>L2 .and. J>L3 .and. J<L4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 180 .and. elx(N) < 270 ) then
                       if ( J<L1 .and. J<L2 .and. J>L3 .and. J>L4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 270 .and. elx(N) < 360 ) then
                       if ( J>L1 .and. J<L2 .and. J<L3 .and. J>L4 ) MAP(I,J)=' '
                    end if
                 end do
              end do
           else
              do J=JS,JE
                 do I=IS,IE
                    MAP(I,J)=' '
                 end do
              end do
           end if
        else
           if ( elx(N) /= 0 ) then
              ang=REAL(elx(N))*PI/180.0
              if ( IRS(N) < 1 ) IS=(IRS(N)-1)/KSKY+1
              if ( IRE(N) > isky ) IE=(IRE(N)-1)/KSKY+1
              if ( JRS(N) < 1 ) JS=(JRS(N)-1)/KSKY+1
              if ( JRE(N) > jsky ) JE=(JRE(N)-1)/KSKY+1
              brx=(IE-IS)/2+IS
              bry=(JE-JS)/2+JS
              do J=JS,JE
                 do I=IS,IE
                    bx=aint((I-brx)*cos(-ang)+(J-bry)*sin(-ang)+brx)
                    by=aint(-(I-brx)*sin(-ang)+(J-bry)*cos(-ang)+bry)
                    if ( J==JS .and. I==IS ) then
                       ssbx=bx
                       ssby=by
                    else if ( J==JS .and. I==IE ) then
                       sebx=bx
                       seby=by
                    else if ( J==JE .and. I==IS ) then
                       esbx=bx
                       esby=by
                    else if ( J==JE .and. I==IE ) then
                       eebx=bx
                       eeby=by
                    end if
                 end do
              end do
              do J=1, jsky
                 do I=1,isky
                    J1=(ssby-seby)/(ssbx-sebx)*I+ssby-ssbx*(ssby-seby)/(ssbx-sebx)
                    J2=(esby-ssby)/(esbx-ssbx)*I+esby-esbx*(esby-ssby)/(esbx-ssbx)
                    J3=(esby-eeby)/(esbx-eebx)*I+esby-esbx*(esby-eeby)/(esbx-eebx)
                    J4=(eeby-seby)/(eebx-sebx)*I+eeby-eebx*(eeby-seby)/(eebx-sebx)
                    if ( elx(N) > 0 .and. elx(N) < 90 ) then
                       if ( J<J1 .or. J<J2 .or. J>J3 .or. J>J4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 90 .and. elx(N) < 180 ) then
                       if ( J>J1 .or. J<J2 .or. J<J3 .or. J>J4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 180 .and. elx(N) < 270 ) then
                       if ( J>J1 .or. J>J2 .or. J<J3 .or. J<J4 ) MAP(I,J)=' '
                    end if
                    if ( elx(N) > 270 .and. elx(N) < 360 ) then
                       if ( J<J1 .or. J>J2 .or. J>J3 .or. J<J4 ) MAP(I,J)=' '
                    end if
                 end do
              end do
           else
              if ( js > 1 ) then
                 do j=1, js-1
                    do i=1, isky
                       MAP(i,j)=' '
                    end do
                 end do
              end if
              do J=JS,JE
                 if ( is > 1 ) then
                    do I=1,is-1
                       MAP(I,J)=' '
                    end do
                 end if
                 if ( ie < isky ) then
                    do I=ie+1,isky
                       MAP(I,J)=' '
                    end do
                 end if
              end do
              if ( je < jsky ) then
                 do j=je+1,jsky
                    do i=1, isky
                       MAP(i,j)=' '
                    end do
                 end do
              end if
           end if
        end if
     else if ( JRE(N) == -999 ) then      ! shape of the region is a circle
        IC=(IRS(N)-1)/KSKY+1
        JC=(IRE(N)-1)/KSKY+1
        KR=JRS(N)/KSKY
        KR=KR*KR
        if (nlp /= 0) write(nlp,'(5x,''CIRCLE (Xc,Yc) = ('',i5,'','', &
             &           i5,''),   R ='',i5)') IRS(N),IRE(N),JRS(N)
        if ( cio(n) == 'i' ) then
           do J=1, JSKY
              Y2=(J-JC)*(J-JC)
              do I=1, ISKY
                 X2=(I-IC)*(I-IC)
                 if ( (X2+Y2) < KR ) MAP(I,J)=' '
              end do
           end do
        else
           do J=1, JSKY
              Y2=(J-JC)*(J-JC)
              do I=1, ISKY
                 X2=(I-IC)*(I-IC)
                 if ( (X2+Y2) > KR ) MAP(I,J)=' '
              end do
           end do
        end if
     else      ! shape of the region is a ellipse
        write(nlp,'(5x,''ELLIPSE (Xc,Yc) = ('',i5,'','',i5,''),   LR ='', &
             &           i5,''   SR ='',i5,''   A ='',i5)') &
             &           elx(N),ely(N),IRS(N),IRE(N),JRS(N)
        if ( IRS(N) < IRE(N) ) then
           exchg=IRS(N)
           IRS(N)=IRE(N)
           IRE(N)=exchg
        end if
        IC=(elx(N)-1)/KSKY+1
        JC=(ely(N)-1)/KSKY+1
        RA=IRS(N)/KSKY
        RB=IRE(N)/KSKY
        RA=RA**2
        RB=RB**2
        ang=REAL(JRS(N))*PI/180.0
        if ( cio(n) == 'i' ) then
           do J=1, JSKY
              Y3=RA/RB*(J-JC)**2
              do I=1, ISKY
                 X3=(I-IC)**2
                 if ( JRS(N) /= 0 ) then
                    X3=((I-IC)*cos(ang)+(J-JC)*sin(ang))**2
                    Y3=(-(I-IC)*sin(ang)+(J-JC)*cos(ang))**2*RA/RB
                 end if
                 if ( (X3+Y3) < RA ) MAP(I,J)=' '
              end do
           end do
        else
           do J=1, JSKY
              Y3=RA/RB*(J-JC)**2
              do I=1, ISKY
                 X3=(I-IC)**2
                 if ( JRS(N) /= 0 ) then
                    X3=((I-IC)*cos(ang)+(J-JC)*sin(ang))**2
                    Y3=(-(I-IC)*sin(ang)+(J-JC)*cos(ang))**2*RA/RB
                 end if
                 if ( (X3+Y3) > RA ) MAP(I,J)=' '
              end do
           end do
        end if
     end if
  end do
  write(nlp,'(/)')
  !     print *,'before map'
  !     call pltsky(map,isky,jsky)
  !     print *,'map'
  do K=1,limitr
     NDATA=0
     do J=1,JSKY
        do I=1,ISKY
           if (MAP(I,J) /= ' ') then
              NDATA=NDATA+1
              X(NDATA)=I-IOFF
              Y(NDATA)=J-JOFF
              Z(NDATA)=SKY(I,J)
           end if
        end do
     end do
     !     *** FITTING***
     call PLANE(X,Y,Z,NDATA,kfit,coef,SD)
     !     *** PRINT DATA ***
     if (nlp /= 0) call PRCOEF(nlp,coef,kfit,SD,IOFF,JOFF)
     !     *** EXIT ***
     if (K == limitr) GO TO 1000
     !     *** REJECTION ***
     REJECT=SD*FSD(K)
     print '(''  Rejection loop='',I1,3X,''S.D.='',F10.3,3X, &
     &     ''Ndata='',I6)', K-1,SD,NDATA
     do N=1,NDATA
        XX=X(N)
        YY=Y(N)
        call PLYNM2(XX,YY,coef,kfit,ZZ)
        ER=ABS(ZZ-Z(N))
        if (ER > REJECT) then
           IREJ=NINT(X(N))+IOFF
           JREJ=NINT(Y(N))+JOFF
!!!            I1=IREJ-IJR
           I1=IREJ-IJR(K)
           if (I1 <    1) I1=1
!!!            I2=IREJ+IJR
           I2=IREJ+IJR(K)
           if (I2 > ISKY) I2=ISKY
!!!            J1=JREJ-IJR
           J1=JREJ-IJR(K)
           if (J1 <    1) J1=1
!!!            J2=JREJ+IJR
           J2=JREJ+IJR(K)
           if (J2 > JSKY) J2=JSKY
           do JJ=J1,J2
              do II=I1,I2
                 MAP(II,JJ)=' '
              end do
           end do
        end if
     end do
  end do
  
1000 return

end SUBROUTINE SkfitC

!----------------------------------------------------------------------
SUBROUTINE PRCOEF(nlp,coef,kfit,SD,IOFF,JOFF)
  
  real(8) ::   coef(21)
  
  !     *** PRINT POLYNOMIAL COEFFICIENTS ***
  write(nlp,'(/5X,''Coefficients of polynomial for sky-matrix''/ &
       &     10X,''Origin of coordinate = ( '',I3,'' , '',I3,'' )'')') IOFF,JOFF
  print '(5x,''Coefficients of polynomial for sky-matrix '')'
  
  write(nlp,'(6X,''0th  '', f12.5)') coef(1)
  write( * ,'(6X,''0th  '', f12.5)') coef(1)
  if ( kfit >= 1 ) then 
     write(nlp,'(6X,''1st  '',2f12.5)') coef(2),coef(3)
     write( * ,'(6X,''1st  '',2f12.5)') coef(2),coef(3)
     if ( kfit >= 2 ) then
        write(nlp,'(6X,''2nd  '',3f12.5)') coef(4),coef(5),coef(6)
        write( * ,'(6X,''2nd  '',3f12.5)') coef(4),coef(5),coef(6)
        if ( kfit >= 3 ) then
           write(nlp,'(6X,''3rd  '',4f12.5)') coef(7),coef(8),coef(9),coef(10)
           write( * ,'(6X,''3rd  '',4f12.5)') coef(7),coef(8),coef(9),coef(10)
           if ( kfit >= 4 ) then
              write(nlp,'(6X,''4th  '',5f12.5)') &
                      &     coef(11),coef(12), &
              &     coef(13),coef(14),coef(15)
              write( * ,'(6X,''4th  '',5f12.5)') coef(11),coef(12), &
              &     coef(13),coef(14),coef(15)
              if ( kfit >= 5 ) then
                 write(nlp,'(6X,''5th  '',6f12.5)') &
                      & coef(16),coef(17),coef(18),coef(19),coef(20),coef(21)
                 write( * ,'(6X,''5th  '',6f12.5)') &
                      & coef(16),coef(17),coef(18),coef(19),coef(20),coef(21)
              end if
           end if
        end if
     end if
  end if
  
  write(nlp,'(16X,''sigma= '',f15.7)') SD
  
  return

end SUBROUTINE PRCOEF

!----------------------------------------------------------------------
subroutine skysb(g,iext,jext,ksky,coef,kfit,ioff,joff,blank,skyval)
  
  !     *** sky subtraction ***
  !     xx, yy ... coordinate on sky-matrix
  
  real(8) :: coef(21),xx,yy,zz,skysum
  real(4) :: g(iext,jext)
  
  skyval=1.0
  skysum=0.0
  nef=0
  
  do j=1,jext
     yy=(real(j)-0.5)/ksky+0.5-joff
     do i=1,iext
        gdum = g(i,j)
        if ( abs((gdum-blank)/gdum) > 0.01  ) then
           nef=nef+1
           xx=(real(i)-0.5)/ksky+0.5-ioff
           call plynm2(xx,yy,coef,kfit,zz)
           g(i,j)= gdum - zz
           skysum= skysum + zz
        end if
     end do
  end do
  print *,'effective pixels=',nef,' in ',iext*jext
  skyval=skysum/dble(nef)
  
  return

end subroutine skysb

!----------------------------------------------------------------------
SUBROUTINE RESMTC(SKY,ISKY,JSKY,coef,kfit,RES,IOFF,JOFF)
  
  !     *** CREATE SKY-FITTING RESIDUAL MATRIX ***
  
  real(4) :: SKY(ISKY,JSKY),RES(ISKY,JSKY)
  real(8) :: coef(21), XX, YY, ZZ
  
  do J=1,JSKY
     YY=J-JOFF
     do I=1,ISKY
        XX=I-IOFF
        call PLYNM2(XX,YY,coef,kfit,ZZ)
        RES(I,J)=(SKY(I,J)-ZZ)/ZZ
     end do
  end do
  
  return

end SUBROUTINE RESMTC

!**********************************************************************

!                     < CRDREGN >

!**********************************************************************
SUBROUTINE CRDREGN(iext,jext,IL,JL,IH,JH,CIO,NRG,NMAX)
  
  !     INPUT
  !     iext, jext      : Dimension of the image
  !     NMAX            : Maximum number of regions to be defined
  !     OUTPUT
  !     NRG             : Number of the regions defined
  !     (IL, JL)        : Coordinate of the lower-left  corner of the region
  !     (IH, JH)        : Coordinate of the upper-right corner of the region
  !     CIO             : omit inside or outside of the circle/box
  
  !     INTERNAL PARAMETER
  
  character :: code, cio(nmax)
  integer   :: IL(nmax), JL(nmax), IH(nmax), JH(nmax)
  
  print *, '============================================='
  print *, 'Assign rejection areas by cursor'
  print *, '        BOX and CIRCLE modes are available.'
  print *, '==============================================='
  print *, '   c: locate for CIRCLE   (inside)       '
  print *, '             first center, then radius'
  print *, '   C: locate for CIRCLE   (outside)       '
  print *, '             first center, then radius'
  print *, '   b: locate for RECTANGLE(inside)       '
  print *, '             first lower-left, then upper-right'
  print *, '   B: locate for RECTANGLE(outside)       '
  print *, '             first lower-left, then upper-right'
  print *, '   q/Q: quit            '
  print *, '-----------------------------------------------'
  nrg=0
  do i=1,nmax
     call PGCURS(x1,y1,code)
     call PGPT(1,x1,y1,13)
     if ( code == 'q' .or. code == 'Q' ) go to 999
     if ( code == 'b' ) then ! rectangle-mode
        print *, 'corner of a box was defined.'
        nrg=nrg+1
        cio(nrg)='i'        ! inside of the box should be rejected.
        IL(nrg)=x1
        if(IL(nrg) <= 1) IL(nrg) = 1
        if(IL(nrg) >= iext) IL(nrg) = iext
        JL(nrg)=y1
        if(JL(nrg) <= 1) JL(nrg) = 1
        if(JL(nrg) >= jext) JL(nrg) = jext
        print *, '    next  : Give another corner'
        call PGBAND(0,0,x1,y1,x2,y2,code)
        IH(nrg)=x2
        if(IH(nrg) <= 1) IH(nrg) = 1
        if(IH(nrg) >= iext) IH(nrg) = iext
        JH(nrg)=y2
        if(JH(nrg) <= 1) JH(nrg) = 1
        if(JH(nrg) >= jext) JH(nrg) = jext
        if ( IH(nrg) < IL(nrg) ) then
           exchg = IL(nrg)
           IL(nrg) = IH(nrg)
           IH(nrg) = exchg
           x1 = IL(nrg)
           x2 = IH(nrg)
        end if
        if ( JH(nrg) < JL(nrg) ) then
           exchg = JL(nrg)
           JL(nrg) = JH(nrg)
           JH(nrg) = exchg
           y1 = JL(nrg)
           y2 = JH(nrg)
        end if
        call SPG_BOX2(x1,x2,y1,y2,2,6,3,1)
     else if ( code == 'B' ) then ! rectangle-mode
        print *, 'corner of a box was defined.'
        nrg=nrg+1
        cio(nrg)='o'        ! outside of the box should be rejected.
        IL(nrg)=x1
        if(IL(nrg) <= 1) IL(nrg) = 1
        if(IL(nrg) >= iext) IL(nrg) = iext
        JL(nrg)=y1
        if(JL(nrg) <= 1) JL(nrg) = 1
        if(JL(nrg) >= jext) JL(nrg) = jext
        print *, '    next  : Give another corner'
        call PGBAND(0,0,x1,y1,x2,y2,code)
        IH(nrg)=x2
        if(IH(nrg) <= 1) IH(nrg) = 1
        if(IH(nrg) >= iext) IH(nrg) = iext
        JH(nrg)=y2
        if(JH(nrg) <= 1) JH(nrg) = 1
        if(JH(nrg) >= jext) JH(nrg) = jext
        if ( IH(nrg) < IL(nrg) .and. JH(nrg) < JL(nrg) ) then
           exchg = IL(nrg)
           IL(nrg) = IH(nrg)
           IH(nrg) = exchg
           chg = JL(nrg)
           JL(nrg) = JH(nrg)
           JH(nrg) = exchg
        end if
        if ( IH(nrg) > IL(nrg) .and. JH(nrg) < JL(nrg) ) then
           exchg = JL(nrg)
           JL(nrg) = JH(nrg)
           JH(nrg) = exchg
        end if
        if ( IH(nrg) < IL(nrg) .and. JH(nrg) > JL(nrg) ) then
           exchg = IL(nrg)
           IL(nrg) = IH(nrg)
           IH(nrg) = exchg
        end if
        x1=IL(nrg)
        x2=IH(nrg)
        y1=JL(nrg)
        y2=JH(nrg)
        call SPG_BOX2(x1,x2,y1,y2,3,6,2,1)
     else if ( code == 'c' ) then ! circle-mode
        print *, 'center of a circle was defined.'
        nrg=nrg+1
        cio(nrg)='i'    ! inside of the circle should be rejected.
        IL(nrg)=x1
        if(IL(nrg) <= 1) IL(nrg) = 1
        if(IL(nrg) >= iext) IL(nrg) = iext
        IH(nrg)=y1
        if(IH(nrg) <= 1)    IH(nrg) = 1
        if(IH(nrg) >= jext) IH(nrg) = jext
        print *, '    next  : assign radius'

        call PGBAND(0,0,x1,y1,x2,y2,code)
        radius=sqrt( (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1) )
        JL(nrg)=INT(radius+0.5)
        JH(nrg)=-999
        call SPG_CIR2(x1,y1,radius,2,6,3,1)
     else if ( code == 'C' ) then ! circle-mode
        print *, 'center of a circle was defined.'
        nrg=nrg+1
        cio(nrg)='o'    ! outside of the circle should be rejected.
        IL(nrg)=x1
        if(IL(nrg) <= 1) IL(nrg) = 1
        if(IL(nrg) >= iext) IL(nrg) = iext
        IH(nrg)=y1
        if(IH(nrg) <= 1)    IH(nrg) = 1
        if(IH(nrg) >= jext) IH(nrg) = jext
        print *, '    next  : assign radius'
        call PGBAND(0,0,x1,y1,x2,y2,code)
        radius=sqrt( (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1) )
        JL(nrg)=INT(radius+0.5)
        JH(nrg)=-999
        call SPG_CIR2(x1,y1,radius,3,6,2,1)
     end if
  end do
  if ( nrg == 0 ) print *, 'No region is defined!'
  
  
999 return

end SUBROUTINE CRDREGN

!----------------------------------------------------------------------
subroutine getclpar(image1,image2,kfit,checko,rrange,limitr, &
     &     HIGHB,interact,skypar,savereg,nlp,outfile,reintrct, rfile)
  
  character ::  image1*(*), image2*(*), outfile*(*)
  character ::  checko*5, interact*5, skypar*80, savereg*5
  character ::  reintrct*5, rfile*80
  
  call clargc (2, image2, irc)
  if ( irc /= 0 ) then
     print '(''Enter       output   image name: '',$)'
     read *, image2
  end if
  
  call clargi (3, kfit, irc)
  if ( irc /= 0 ) then
     print '(''Enter order of plynomial ===> '',$)'
     read *, kfit
  end if
  
  call clargc (4, checko, irc)
  if ( irc /= 0 ) checko='yes'
  
  call clargr (5, rrange, irc)
  if ( irc /= 0 ) rrange=3.0
  
  call clargi (6, limitr, irc)
  if ( irc /= 0 ) then
     print '(''Enter number of iterations  ===> '',$)'
     read *, limitr
  end if
  if ( limitr<1 ) limitr = 1
  
  call clargr (7, HIGHB, irc)
  if ( irc /= 0 ) then
     print '(''Enter CUT-OFF value ===> '',$)'
     read *, HIGHB
  end if
  
  call opniaf(image2,'sslog',outfile,nlp,irc)
  if ( irc /= 0 ) stop
  
  write(nlp,'(5x,''INPUT  Image :'',a40)')  image1
  write(nlp,'(5x,''OUTPUT Image :'',a40/)') image2
  
  call clargc (8, interact, irc)
  if ( irc /= 0 ) interact='yes'
  
  call clargc (9, skypar, irc)
  if ( irc /= 0 ) then
     print '(''Enter parameter-file for areas ===> '',$)'
     read '(a)', skypar
  end if
  
  call clargc (10, savereg, irc)
  if ( irc /= 0 ) savereg='yes'

  call clargc (11, reintrct, inc)
  if ( irc /= 0 ) then
     reintrct='yes'
  end if

  if ( reintrct=='no' ) then
     call clargc (12, rfile, irc)
     if ( irc /= 0 ) then
        print '(''Enter ds9 reg-file : '',$)'
        read *, rfile
     end if
  end if

  return

end subroutine getclpar

!------------------------------------------
SUBROUTINE MAPREJ(MAP,RES,ISKY,JSKY)
  
  character :: map(isky,jsky)
  real(4)   :: RES(isky,jsky)
  
  do j=1,jsky
     do i=1,isky
        if ( MAP(I,J)  ==  ' ' ) then
           RES(I,J)=1.0
        else
           RES(I,J)=0.0
        end if
     end do
  end do
  
  return

end SUBROUTINE MAPREJ

!----------------------------------------------------------------
SUBROUTINE DEF_WSIZE(iext,jext,width,hight,ratio)
  
  if ( iext >= (jext*1.75) ) then
     width=7.0
     ratio=real(jext)/real(iext)*1.25
  else if ( iext >= jext .or. jext < (iext*1.2) ) then
     width=5.0
     ratio=real(jext)/real(iext)*1.2
  else
     hight=8.0
     ratio=real(jext)/real(iext)*1.1
     width=hight/ratio
  end if
  
  return

end SUBROUTINE DEF_WSIZE

!----------------------------------------------------------------
SUBROUTINE pltsky(map,isky,jsky)
  
  character :: map(isky,jsky)
  
  open (49,file='zdum')
  
  do j=1,jsky,2
     write(49,'(128a1)') ( map(i,j), i=1,isky-1,2 )
  end do
  write(49,*) '----- '
  
  return

end SUBROUTINE pltsky

!-------------------------------------------------------------------------
SUBROUTINE RDDSREG(rfile,iext,jext,IL,JL,IH,JH,CIO,NRG,elx,ely,nmax)

  character :: rfile*80, line*70, cio(nmax)
  integer :: IL(nmax), JL(nmax), IH(nmax), JH(nmax), elx(nmax), ely(nmax)
  real(4) :: wid, hei, angl, rad, yrad

  do i=1, nmax
     elx(nmax)=0
  end do
  open(81, file=rfile)
  nrg=0
  do i=1, 999
     read(81, '(a70)', end=666) line
     is=index(line, '(')+1
     ie=index(line, ')')-1
     if ( line(1:3)=='phy' ) then
        print *
        print '(''##### ERROR: change file coordinate system from "physical" for "image"'')'
        print *
        stop
     end if
     if ( line(1:3)=='box' .or. line(1:3)=='-bo' ) then
        nrg=nrg+1
        if ( line(1:3)=='box' ) cio(nrg)='i'  ! inside of the box should be rejected.
        if ( line(1:3)=='-bo' ) cio(nrg)='o'  ! outside of the box should be rejected.
        read(line(is:ie), *) xx, yy, wid, hei, angl
        IL(nrg)=xx-wid/2
        IH(nrg)=xx+wid/2
        JL(nrg)=yy-hei/2
        JH(nrg)=yy+hei/2
        elx(nrg)=angl
        if (elx(nrg)==0 .or. elx(nrg)==90 .or. elx(nrg)==270 ) then
           if( IL(nrg) <= 1 ) IL(nrg)=1
           if( IL(nrg) >= iext ) IL(nrg)=iext
           if( JL(nrg) <= 1 ) JL(nrg) = 1
           if( JL(nrg) >= jext ) JL(nrg) = jext
           if( IH(nrg) <= 1 ) IH(nrg) = 1
           if( IH(nrg) >= iext ) IH(nrg) = iext   
           if( JH(nrg) <= 1 ) JH(nrg) = 1
           if( JH(nrg) >= jext ) JH(nrg) = jext
        end if
     else if ( line(1:3)=='cir' .or. line(1:3)=='-ci' ) then
        nrg=nrg+1
        if ( line(1:3)=='cir' ) cio(nrg)='i'
        if ( line(1:3)=='-ci' ) cio(nrg)='o'
        read(line(is:ie), *) xx, yy, rad
        IL(nrg)=xx
        IH(nrg)=yy
        if( IL(nrg) <= 1 ) IL(nrg)=1
        if( IL(nrg) >= iext ) IL(nrg)=iext
        if( IH(nrg) <= 1) IH(nrg ) = 1
        if( IH(nrg) >= iext) IH(nrg ) = iext   
        JL(nrg)=INT(rad+0.5)
        JH(nrg)=-999
     else if ( line(1:3)=='ell' .or. line(1:3)=='-el' ) then
        nrg=nrg+1
        if ( line(1:3)=='ell' ) cio(nrg)='i'
        if ( line(1:3)=='-el' ) cio(nrg)='o'
        read(line(is:ie), *) xx, yy, rad, yrad, angl
        IL(nrg)=rad
        IH(nrg)=yrad
        JL(nrg)=angl
        JH(nrg)=-555
        elx(nrg)=xx
        ely(nrg)=yy
     end if
  end do

666  if ( nrg == 0 ) print *, '##### ERROR: No region is defined!'

  close(81)

end SUBROUTINE RDDSREG

        
