program smooth
  
  ! Original version by M. Hamabe 1999-07-23 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-09-25 (for Fortran90)
  ! Updated by M. Hamabe  2007-10-23 (opninp)

  real, allocatable :: G(:,:), WORK(:)
  character image*80, comments*50
  integer   im, irc, bitpix
  character MENU*1,COMENT*40
  character title*40
  dimension IFLT(-4:4,-4:4)
  
  print *
  call opninp (1,im,0,image,title,iext,jext,irc)
  if ( irc/=0 ) go to 999
  
  call clargc (2, image, irc)
  if ( irc /= 0 ) then
     print '(''Enter       output   image name: '',$)'
     read (*,*) image
  end if
  
  bitpix=-32
  call IMGCOPY(im,nim,bitpix,image,irc)
  if ( irc /= 0 ) goto 999
  
  allocate( G(iext, jext) )   ! ptr1=malloc(iext*jext*4)
  call MATRD(im,G,IEXT,JEXT,irc)
  if ( irc /= 0 ) go to 999
  call FCLOSE(im,irc)
  if ( irc /= 0 ) go to 999
  
  !     *** COMPUTE THE VALUE TO BE FILLED IN MARGIN OF WORK ARRAY ***
  NBUFF=(IEXT+8)*(JEXT+8)
  allocate( WORK( NBUFF ) )   ! ptr2=malloc( NBUFF*4 )
  !     ptr2=malloc( (iext+8)*(jext+8)*4 )
  call MARVAL (G,IEXT,JEXT,VALUE,WORK,NBUFF,KCORD)
  if ( KCORD  /=  0 ) print *, 'MARVAL(RC)=', KCORD
  
1000 print *
  print *, '*---------- SELECT MODE OF SMOOTHING -----------*'
  print *, '|  1: VARIABLE-WIDTH GAUSSIAN BEAM (INTENSITY)  |'
  print *, '|  2: GAUSSIAN BEAM FILTER                      |'
  print *, '|  3: REDUCTION SMOOTHING                       |'
  print *, '|  4: MEDIAN FILTER                             |'
  print *, '*-----------------------------------------------*'
  print '(''  Enter menu number (<1>/2/3/4) ===> '',$)'
  READ '(A)', MENU
  print *
  
  if ( MENU == '2' ) then
     comments='MODE: Gauusian beam filter'
  else if ( MENU == '3' ) then
     comments='MODE: Reduction smoothing'
  else if ( MENU == '4' ) then
     comments='MODE: Asymp. median filter'
  else
     comments='MODE: Variable Guss. beam (intensity)'
  end if
  call adhstry(nim,'SMOOTH',6,comments,irc)
  !     *** APPLY SMOOTHING ***
  if (MENU == '2') then
     call CRTFLT(IFLT,IWIDTH,ISUM,COMENT)
     print *, 'Data are being smoothed ...'
     call FLTR2D(G,WORK,IEXT,JEXT,VALUE,IFLT,IWIDTH,ISUM)
  ELSE if (MENU == '3') then
     call RDSMTH (G,IEXT,JEXT,WORK,IFLT,COMENT)
  ELSE if (MENU == '4') then
1300 continue
  print '(''Enter half width of filter (iw,jw; max. 4) ===> '',$)'
  READ *, IW,JW
  if ( IW  <  1 .OR. IW  >  4 ) GO TO 1300
  if ( JW  <  1 .OR. JW  >  4 ) GO TO 1300
  write(COMENT,100) IW,JW
100 FORMAT ('ASYM. MEDIAN FILTER; HALF WIDTH=',I2,'*',I2)
  print *, 'DATA ARE BEING SMOOTHED ...'
  call MDFLIJ(G,WORK,IEXT,JEXT,VALUE,IW,JW)
  write(comments,'(''Half width ='',i2,'' x'',i2)') IW,JW
  call adhstry(nim,'SMOOTH',0,comments,irc)
ELSE
   print '(''Enter threshold value of intensity ===> '',$)'
   READ *, THRES
   write(COMENT,'(''VARGAU(INT.); THRESHOLD='',F6.1)') THRES
   print *, 'DATA ARE BEING SMOOTHED ...'
   call GAUSSV(G,WORK,IEXT,JEXT,VALUE,THRES)
   write(comments,'(''Threshold ='', f6.1)') THRES
   call adhstry(nim,'SMOOTH',0,comments,irc)
end if
print *

call MATWT (nim,G,IEXT,JEXT,irc)
if ( irc /= 0 ) go to 999

call FCLOSE(nim,irc)
if ( irc /= 0 ) go to 999

9000 deallocate(G)   ! call free(ptr1) 
deallocate(WORK)   ! call free(ptr2)
stop

999 call PUTEMSG(irc)
deallocate(G)   ! call free(ptr1)
deallocate(WORK)   ! call free(ptr2)

END program smooth

! ---------------------------------------------------------------------
SUBROUTINE RDSMTH (G,IEXT,JEXT,WORK,IFLT,COMENT)

  character cnum*10, COMENT*40
  dimension G(IEXT,JEXT),WORK(IEXT+8,JEXT+8),IFLT(-4:4,-4:4)

  NBUFF=(IEXT+8)*(JEXT+8)
  !     *** DEFINE SMOOTHING MODE ***
1000 continue
  print *
  print *, '*--------- REDUCTION SMOOTHING -----------*'
  print *, '|                   KRDF  KWIDTH  SIGMA   |'
  print *, '|    Heavy            8      1     0.5    |'
  print *, '|    Medium           4      1     0.5    |'
  print *, '|    Light            2      1     0.5    |'
  print *, '|   Range of value  (2:8)  (0:4) (.5:2.0) |'
  print *, '*-----------------------------------------*'
  
  !     *** DEFINE PARAMETERS ***
  print *
  print '(''Enter reduction factor (2:8) <4> ===> '',$)'
  read (*,'(a)') cnum
  if ( cnum == '' ) then
     KRDF=4
  else
!     read(cnum,'(BN,i)') krdf
     read(cnum,*) krdf
  end if
  if ( KRDF < 2 ) KRDF=2
  if ( KRDF > 8 ) KRDF=8
  print '(''      Reduction factor = '',i1)', krdf
  
  print '(''Enter median filter box size (0:4) <1> ===> '',$)'
  read '(a)', cnum
  if ( cnum == '' ) then
     KWIDTH=1
  else
!     read(cnum,'(BN,i)') KWIDTH
     read(cnum,*) KWIDTH
  end if
  if ( KWIDTH < 0 ) KWIDTH=0
  if ( KWIDTH > 4 ) KWIDTH=4
  print '(''      Median filter box size = '',i1)', Kwidth
  
  print '(''Enter sigma (0.5:2.0) <0.5> ===> '',$)'
  read '(a)', cnum
  if ( cnum == '' ) then
     sigma=0.5
  else
     read(cnum,*) sigma
  end if
  if ( sigma < 0.5 ) sigma=0.5
  if ( sigma > 2.0 ) sigma=2.0
  print '(''      Sigma = '',f5.2)', sigma
  
  IDIM=IEXT/KRDF
  JDIM=JEXT/KRDF
  !     *** REDUCE THE INPUT IMAGE ***
  print *
  print *, 'Input image is being reduced ...'
  call REDUCE(G,IEXT,JEXT,WORK,IDIM,JDIM,KRDF,KRTN)
  !     *** APPLY MEDIAN FILTERING ***
  if (KWIDTH > 0) then
     print *, 'Reduced image is being smoothed (median) ...'
     call MARVAL (WORK,IDIM,JDIM,VALUE,G,NBUFF,KCODE)
     if ( KCODE  >=  1000 ) print *, 'KCODE: ',KCODE
     call MEDIAN(WORK,G,IDIM,JDIM,VALUE,KWIDTH)
  end if
  !     *** EXPAND THE REDUCED MATRIX ***
  print *, 'Reduced image is being expanded ...'
  call EXPAND(WORK,IDIM,JDIM,G,IEXT,JEXT,KRDF,KRTN)
  !     *** APPLY GAUSSIAN-BEAM SMOOTHING TO THE EXPANDED MATRIX ***
  print *, 'Expanded image is being smoothed (Gauss) ...'
  call CRTGAU(SIGMA,IFLT,IWIDTH,ISUM,IREC)
  call MARVAL (G,IEXT,JEXT,VALUE,WORK,NBUFF,KCODE)
  if ( KCODE  >=  1000 ) print *, 'KCODE: ', KCODE
  call FLTR2D(G,WORK,IEXT,JEXT,VALUE,IFLT,IWIDTH,ISUM)

  write(COMENT,100) KRDF,KWIDTH,SIGMA
100 FORMAT ('REDUCTION: KRDF=',I1,1X,'KWIDTH=',I1,1X,'SIGMA=',F5.1)

9000 return

END SUBROUTINE RDSMTH
