program vplot
  
!     PROFILE PLOTTING PROGRAM (PLOT.FOR)

!     <PL.FOR>    AUTHOR : John   Kormendy
!            last UPDATE : Masaru HAMABE   1986-03-12
!     <COMP.FOR>  AUTHOR : Masaru HAMABE   1986-02-05
!            last UPDATE : Masaru HAMABE   1986-03-12
!     <PLOT.FOR>
!     CREATE : Masaru HAMABE   1986-03-12      FROM PL.FOR & COMP.FOR
!     UPDATE : Masaru HAMABE   1986-03-23
!     UPDATE : Masaru HAMABE   1986-03-25	 MODEL FITTING
!     UPDATE : Masaru HAMABE   1986-04-23	 MODEL FITTING (X2)
!     <VPLOT.F>
!     UPDATE : Masaru HAMABE   1990-12-12      for SPARC
!     UPDATE : Masaru HAMABE   1992-01-29      
!     UPDATE : Masaru HAMABE   1992-04-16      (Bug fix)      
!     UPDATE : Masaru HAMABE   1992-09-25      (change psfmode etc.)
!     UPDATE : Masaru HAMABE   1994-09-02      (replace MONGO with PGPLOT)
!     UPDATE : Masaru HAMABE   1994-09-04      (surpress calculation of e-el)
!     UPDATE : Masaru HAMABE   1995-07-07      (omit PGPAGE, and PS-file name)
!     UPDATE : Masaru HAMABE   1997-10-31      (omit bell)
!     UPDATE : Masaru HAMABE   2007-10-15      (for Fortran90)

!     W(I,1)	W(I,2)	W(I,3)	W(I,4)	W(I,5)	W(I,6)	W(I,7)	
!     R	LOG(R)	MU	R4	RM	LOG(RM)	RM4	
!     W(I,8)	W(I,9)	W(I,10)
!     ELL	PA	EW	

  parameter (MAXPNT=500)
  character longocat*80
  character fname(10)*50, SOUT*60, char, S1*40, S2*40, BLK*10
  character ident(10)*40, OBJECT*41, CDUM*10, VSTAR*16
  character source*35, band(10), MODE, deflt(2)*40
  character YSH(10)*7, YN, LR, only*5, Cparm(2,2)*20, cer(2,2)*15
  character device*10, hfile*40, hfile0*40, extend*40
  character Cstar*25, pid*3, capon*3, eEll*3
  character PROFDIR*30
  real*4    LOGR(MAXPNT,10), LOGRM(MAXPNT,100), LOGR2(MAXPNT)
  real*4    MU(MAXPNT,10), MU2(MAXPNT), MUDIF(MAXPNT,10), MUC
  integer   Rstyle(0:9), style(2,10), ipk(7), ltype(7)
  dimension ND(10)
  dimension R(MAXPNT,10),  R4(MAXPNT,10)
  dimension RM(MAXPNT,10), R4M(MAXPNT,10)
  dimension ELL(MAXPNT,10), PA(MAXPNT,10)
  dimension EW(MAXPNT,10), W(MAXPNT,10)
  dimension ELLDIF(MAXPNT,10), PADIF(MAXPNT,10)
  dimension Rmax(10), Rmin(10)
  dimension XP(MAXPNT), YP(MAXPNT), X(MAXPNT,10), Y(MAXPNT,10)
  dimension R2(MAXPNT), ELL2(MAXPNT), PA2(MAXPNT), DYS(10)
  dimension SR(MAXPNT), SLOGR(MAXPNT), SR4(MAXPNT),SMU(MAXPNT,3)
  dimension WSR(MAXPNT), WSMU(MAXPNT)
  dimension FS(3,2), FE(3,2), bulge(10)
!							! Masaru 4/28
  dimension last(10)
  
  !     symbol codes :=  fc   oc   fs   os   x   +   ft   ot   *    .
  DATA Rstyle     /17,  21,  16,   0,  5,  2,  13,   7,  3,   1/
  
  
  include  'SPIRAL.INC'
  
  VSTAR= '\\gs\\dstar \\u='
  BLK  = '          '
  ig5k=0
  ig6k=0  ! go to 6000, 7000 are not finished
  ig7k=0
  
  call clargc (1, device, ier)
  if ( ier /= 0 ) device='/xterm'
  if ( device(1:3) == 'tek' ) then
     device='/xterm'
  else if ( device(1:4) == 'xser' ) then
     device='/xserve'
  else if ( device(1:4) == 'xwin' ) then
     device='/xwindow'
  else
     device='inq'
  end if
  call clargc (2, hfile, ier)
  if ( ier /= 0 ) then
     hfile='vplot.ps'
     ier = 0
  end if
  call clargc (3,pid,ier)
  if ( ier /= 0 ) pid='yes'
  call clargc (4,capon,ier)
  if ( ier /= 0 ) capon='yes'
  call clargc (5,eEll,ier)
  if ( ier /= 0 ) eEll='no'
  
  !     define lib-directory
  do i=30,1,-1
     if ( PROFDIR(i:i) == '/' ) goto 1359
  end do
1359 L=i
  if ( L<=1 ) then
     print *, 'Eror: Location of profile library is invalid.'
     deflt(1)=' '
     deflt(2)=' '
  else
     deflt(1)=PROFDIR(1:L)//'ccd.pub'
     deflt(2)=' '
  end if
  
  !----- MODE Selection -------------------------------------------------
  
9000 SOUT = BLK//BLK//BLK//BLK//BLK//BLK
  do  jj=1,2
     do ii=1,2
        Cparm(ii,jj)= '                    '
        cer(ii,jj)  = '               '
     end do
  end do
  print *
  print '(''  Please select MODE'')'
  print '(''    < > : Plot profile'')'
  print '(''     0  : Plot profiles (ask # of profiles) '')'
  print '(''     1  : Plot difference of profiles  '')'
  print '(''     2  : Profile fitting  (E galaxies) '')'
  print '(''     3  : Profile fitting  (disk galaxies)  '',$)'
  read '(A)', MODE
  if ( MODE /= ' ' .and. MODE /= '0' .and. MODE /= '1' .and. &
       &     MODE /= '2' .and. MODE /= '3' ) go to 9000
  read (MODE,'(I1)') IM
  if ( IM>3 ) go to 999
  ifit=0
  if ( im == 2 ) then
     im=0
     MODE=' '
     ifit=1				! default  kind=6
  else if ( im == 3 ) then
     im=0
     MODE=' '
     ifit=2			! default  kind=4
  end if
  do  I=1,10
     last(I) = 0
  end do
  
  !----- Input profile  for MODE-0 ----------------------------------------
8000 continue
  if ( IM == 0 .and. ig6k==0 .and. ig7k==0 ) then
     NPR = 1  ! 	number of profiles to be plotted		
     IPR = 1  !     number of profiles to be used
     print *
     print '(''  Program to plot mu(r, log r, r**.25) ''/ )'
     IR = 0
     NSTAR = 0    ! star-profile is not plotted
     NDEV  = 0    ! models are not plotted
! 5000    CONTINUE
     if ( MODE == ' ' ) then
        call DATAIN (fname(IPR),ident(IPR),ND(IPR),W, &
             &       Rmin(IPR),Rmax(IPR),source,band(IPR), &
             &       multi,deflt,IR,IM,last,only,irc)
        if ( irc /= 0 ) go to 999
        call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,IPR,ND(IPR))
     else
        print '(''  number of profiles ? '',$)'
        read *, NPR
        IPR=NPR
        do I=1,NPR
           call DATAIN (fname(I),ident(I),ND(I),W, &
                &       Rmin(I),Rmax(I),source,band(I), &
                &       multi,deflt,IR,IM,last,only,irc)
           if ( irc /= 0 ) go to 999
           call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,I,ND(I))
        end do
        MODE=' '
     end if
     
!----- Input profile  for MODE-1 ----------------------------------------
     
  else		! ( IM == 1 )
     if ( ig6k==0 ) then
        NPR = 1             ! number of profiles to be plotted
        IPR = 2             ! number of profiles to be used
        print '(/''  Do you want to shift VICTIM profiles ( Y / <N> ) '',$)'
        read '(A)', YN
        print '(/ ''  number of original profiles <2> : '',$)'
        read '(A)', char
        if ( char == ' ' ) char='2'
        read (char,*) IPR
        NPR=IPR-1
        print '(/'' program to plot delta mu (reference - victim)''/)'
            
!     Input REFERENCE profile
            
        print '(''  reference profile '')'
        call DATAIN (fname(1),ident(1),ND(1),W, &
             &       Rmin(1),Rmax(1),source,band(1), &
             &       multi,deflt,IR,IM,last,only,irc)
        if ( irc /= 0 ) go to 999
        call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,1,ND(1))
        IFLG_REF=0
        if ( only == 'MEAN ') IFLG_REF=1
        print *
        print '(''   number of points = '',I3/)', ND(1)
        print '(''       <0> =  get log R from R   (DEFAULT)'')'
        print '(''   or   1  = keep log R                ?  '',$)'
        read '(A)', LR
        if( LR /= '1' ) then
           print '(30X,''log R <--- R'')'
           do  I = 1, ND(1)
              if(R(I,1)>1.) LOGR(I,1) = LOG10(R(I,1))
           end do
        end if
     end if
     
!        Input VICTIM profile
6000 CONTINUE
     print '('' '')'
     print '(''  profile to be compared to reference: '')'
     do J=2,IPR
        call DATAIN (fname(J),ident(J),ND(J),W, &
             &       Rmin(J),Rmax(J),source,band(J), &
             &       multi,deflt,IR,IM,last,only,irc)
        if ( irc /= 0 ) go to 999
        call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,J,ND(J))
        IFLG_VIC=0
        if ( only == 'MEAN ' ) IFLG_VIC=1
        print *
        print '(''   number of points ='',I3)', ND(J)
        print '('' '')'
        print '(''       <0> =  get log R from R   (DEFAULT)'')'
        print '(''  or    1  = keep log R                ?  '',$)'
        read '(A)', LR
        if( LR /= '1' ) print '(30X,''log R <--- R'')'
        
        if ( YN == 'Y' .or. YN == 'y' ) then
7000       print '('' '')'
           print '(''  '',20X,''delta mu = (reference) - (victim + delta) '')'
           print '('' '',45X,''delta ( <0.0> ) = '',$)'
           read '(A10)', CDUM
           read (CDUM,'(F10.0)') DELTA
           print '('' '')'
           print '('' '',20X'' VICTIM profile shifted by DLOGR   '')'
           print '('' '',45X,''DLOGR ( <0.0> ) = '',$)'
           read '(A10)', CDUM
           read (CDUM,'(F10.0)') DELTAL
           DELTAR = 10.**DELTAL
        else
           DELTAL = 0.0
           DELTAR = 1.0
        end if
        do I=1, ND(J)
           if( LR /= '1' .and. R(I,J)>1. ) LOGR(I,J) = LOG10(R(I,J))
           LOGR(I,J) = LOGR(I,J) + DELTAL
           R(I,J) = R(I,J) * DELTAR
        end do

!           recalculate RmaJ(j) and Rmin(j) after shift
        Rmin(J) = R(1,J)
        Rmax(J) = R(1,J)
        do I=2, ND(J)
           Rmin(J) = min(Rmin(J),R(I,J))
           Rmax(J) = max(Rmax(J),R(I,J))
        end do
        
        Rmin(J) = max(Rmin(1),Rmin(J))
        Rmax(J) = min(Rmax(1),Rmax(J))
        
        do I=1,ND(J)
           if ( IFLG_REF == 0 .and. IFLG_VIC == 0 ) then
              R2    (I) = R    (I,J)
              LOGR2 (I) = LOGR (I,J)
           else
              R2    (I) = RM   (I,J)
              LOGR2 (I) = LOGRM(I,J)
           end if
           MU2   (I) = MU   (I,J)
           ELL2  (I) = ELL  (I,J)
           PA2   (I) = PA   (I,J)
        end do
        do I=1,ND(1)
           if ( IFLG_REF == 0 .and. IFLG_VIC == 0 ) then
              DUM1=LOGR(I,1)
              DUM2=R(I,1)
           else
              DUM1=LOGRM(I,1)
              DUM2=RM(I,1)
           end if
           if ( R(I,1)>=Rmin(J) .and. R(I,1)<=Rmax(J) ) then
              call INTERP(LOGR2,MU2, ND(J),4,DUM1,MUC)	
              MUDIF(I,J-1)=MU(I,1)-MUC-DELTA
              call INTERP(R2,   ELL2,ND(J),4,DUM2,ELLC)
              ELLDIF(I,J-1)=ELL(I,1)-ELLC
              call INTERP(R2,   PA2, ND(J),4,DUM2,PAC)
              PADUM = PA(I,1)-PAC
              if( R(I,1) ==   0.0 ) PADUM = 0.0
              if( PADUM> 90.0 ) PADUM = PADUM-180.0
              if( PADUM<-90.0 ) PADUM = PADUM+180.0
              PADIF(I,J-1) = PADUM
           else
              MUDIF(I,J-1)=1000.0
              ELLDIF(I,J-1)=1000.0
           end if
        end do
     end do
  end if
  
5000 if ( ig5k==1 ) then
     ig5k=0
     if ( MODE == ' ' ) then
        call DATAIN (fname(IPR),ident(IPR),ND(IPR),W, &
             &       Rmin(IPR),Rmax(IPR),source,band(IPR), &
             &       multi,deflt,IR,IM,last,only,irc)
        if ( irc /= 0 ) go to 999
        call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,IPR,ND(IPR))
     else
        print '(''  number of profiles ? '',$)'
        read *, NPR
        IPR=NPR
        do I=1,NPR
           call DATAIN (fname(I),ident(I),ND(I),W, &
                &       Rmin(I),Rmax(I),source,band(I), &
                &       multi,deflt,IR,IM,last,only,irc)
           if ( irc /= 0 ) go to 999
           call COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,I,ND(I))
        end do
        MODE=' '
     end if
     
  end if
  
!----- Input profile end   ----------------------------------------
      
!     default plot is mu(log r) along mean axis, plotted as small dots
!     this can be changed in the interactive section by typing k or .
  
  
  do j=1, 7
     ipk(j)=j-1
     ltype(j)=1
     style(1,j)=Rstyle( ipk(j) )
  end do
  
  kind = 5
  if ( ifit == 1 ) kind=6
  if ( ifit == 2 ) kind=4
  if ( only == 'MAJOR' ) kind=2
  
!     set up vectors to be plotted
  
1 CONTINUE
  kind1  = MOD(kind,10)
  if( kind1>8 ) kind1 = 5
  kind2  = kind/10
  if ( kind2>0 .and. kind2<=2 ) then
     NSTAR = 0
     NDEV  = 0
     do jj=1,2
        do ii=1,2
           Cparm(ii,jj)= '                    '
           cer(ii,jj)  = '               '
        end do
     end do
  else if( kind2>2 ) then
     kind2=2
  end if
  
  if( IM == 0 ) then
!------- for MODE-0 -------------------
     do J=1,NPR
        YSH(J)='       '
        do I=1, ND(J)
           call LOADXY (X,Y,R,LOGR,R4,RM,LOGRM,R4M,MU, &
                &       MU,ELL,PA,kind1,kind2,I,J,I,J)
           if ( kind1 == 8 ) then
              if ( index(source,'r(E-W)') /= 0 ) then
                 x(I,J)=ew(i,J)
                 y(I,J)=mu(i,J)
                 kind2=0
              else if ( index(source,'mu(E-W)') /= 0 ) then
                 x(I,J)=r(i,J)
                 y(I,J)=ew(i,J)
                 kind2=0
              else
                 print '(''  No E-W profile ! '')'
                 go to 2000
              end if
           end if
        end do
     end do
     
  else
!------- for MODE-1 --------------------
     NEND = ND(1)
     do J=1,NPR
        NN=1
        do I=1, NEND
           if ( R(I,1)>=Rmin(J+1) .and. R(I,1)<=Rmax(J+1) ) then
              call LOADXY (X,Y,R,LOGR,R4,RM,LOGRM,R4M,MU, &
                   &       MUDIF,ELLDIF,PADIF,kind1,kind2,NN,J,I,1)
              NN=NN+1
           end if
        end do
        ND(J)=NN-1
     end do
!---------------------------
  end if

!     calculate plot limits
  call PLIMIT(X,Y,Xmin,Xmax,Ymin,Ymax,ND,NPR,kind1,kind2,IM)
  Xmin0 = Xmin
  Xmax0 = Xmax
  Ymin0 = Ymin
  Ymax0 = Ymax
  
!     plot box, tics, labels

1000 continue
  if ( device == 'INQ') then
     call PGBEG(0,'?'//device,1,1)
  else
     call PGBEG(0,device,1,1)
  end if
  
  if ( NDEV>=1 ) NSTAR=0
1001 CONTINUE
  if ( NSTAR>=1 .or. NDEV>=1 ) then
     do I=1, MAXPNT
        if(kind1 == 1) WSR(I)=   SR(I)
        if(kind1 == 2) WSR(I)=SLOGR(I)
        if(kind1 == 3) WSR(I)=  SR4(I)
        if(kind1 == 4) WSR(I)=   SR(I)
        if(kind1 == 5) WSR(I)=SLOGR(I)
        if(kind1 == 6) WSR(I)=  SR4(I)
     end do
  end if
  call TITLAX(IM,IPR,kind1,kind2,band,fname,S1,S2,SOUT)      
  call PGENV(Xmin,Xmax,Ymax,Ymin,-2,-2)
  if ( char == 'h' ) then
     call PGVPORT(0.15,0.85,0.15,0.85)
  else
     call PGVSTAND
  end if
  call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
  if ( pid == 'yes' ) call PGIDEN
  if ( kind<10 ) then
     call PGLABEL(s1,s2,'Luminosity Profile')
  else if ( kind<20 ) then
     call PGLABEL(s1,s2,'Ellipticity Profile')
  else
     call PGLABEL(s1,s2,'Position-angle Profile')
  end if
  Xrange = Xmax-Xmin
  Yrange = Ymax-Ymin
  xdum = Xmin+0.075*Xrange
  Ybase= Ymax-0.033*Yrange*(1+IPR)
  ddy  =      0.010*Yrange
  if ( capon == 'yes' ) then
     do J=1,IPR
        JJ=J
        if ( IM == 1 ) JJ=J-1
        OBJECT=ident(J)(1:30)//' '
        if ( IM == 0 .and. DYS(J) /= 0.0 )  OBJECT=ident(J)(1:30)//YSH(J)
        if ( IM == 1 .and. J == 1 ) OBJECT='+'//ident(J)(1:30)
        if ( IM == 1 .and. J /= 1 ) OBJECT='-'//ident(J)(1:30)
        ydum = Ybase+(J-1)*0.033*Yrange
        if ( IM == 0 .and. DYS(J) /= 0.0 ) then
           call PGTEXT(xdum+Xrange*0.03,ydum,OBJECT(1:37))
        else
           call PGTEXT(xdum+Xrange*0.03,ydum,OBJECT(1:31))
        end if
        if ( IM == 0 .or. J>1 ) then
           if ( ipk(j)>=0 ) then
              call PGPT(1,xdum,ydum-ddy,style(1,jj))
           else
              call PGSLS(ltype(j))
              xp(1)=xdum-Xrange*0.04
              xp(2)=xdum+Xrange*0.02
              yp(1)=ydum-ddy
              yp(2)=ydum-ddy
              call PGLINE(2,xp,yp)
              call PGSLS(1)
           end if
        end if
     end do
  end if
  
  if ( capon == 'yes' ) call pltpar(Xmin,Xmax,Ymin,Ymax,nstar,ndev,Cparm,Cstar,cer,eEll)

!     plot points
!     plot star profile (if exsists)
  
  NTOTAL=0
  do J=1,NPR
     do I=1,ND(J)
        NTOTAL=NTOTAL+1
     end do
  end do
  do J=1,NPR
     do I=1,ND(J)
        XP(I)=X(I,J)
        YP(I)=Y(I,J)
     end do
     if ( ipk(j)>=0 ) then
        call PGPT(nd(j),xp,yp,style(1,j))
     else
        call PGSLS(ltype(j))
        call PGLINE(nd(j),xp,yp)
        call PGSLS(1)
     end if
  end do
  if ( NSTAR>=1 ) then                        ! plot star profile
     call PGSLS(4)
     call PGLINE(MAXPNT,wsr,smu)
     call PGSLS(1)
  else if ( NDEV>=1 ) then                    ! plot model profiles
     if ( capon == 'yes' ) call PLTRANG(FS,FE,Ymin,Ymax,kind1,NDEV)
     do I=1,MAXPNT
        WSMU(I)=SMU(I,1)
     end do
     call PGSLW(1)
     if ( NDEV == 1 ) call PGSLW(3)
     call PGSLS(1)
     if ( NDEV>=2 ) call PGSLS(3)
     call PGLINE(MAXPNT,wsr,wsmu)
     call PGSLW(1)
     call PGSLS(1)
     if ( NDEV>=2 ) then
        do I=1,MAXPNT
           WSMU(I)=SMU(I,2)
        end do
        call PGSLS(2)
        call PGLINE(MAXPNT,wsr,wsmu)
        do I=1,MAXPNT
           WSMU(I)=SMU(I,3)
        end do
        call PGSLW(3)
        call PGSLS(1)
        call PGLINE(MAXPNT,wsr,wsmu)
        call PGSLW(1)
     end if
  end if
  if (char == 'h') then 
     call PGEND
     call PGBEGIN(0,device,1,1)
     print *, 'Type "p" for re-plot'
  end if
  
! ===== INTERACTIVE SECTION =========================================
  
2000 CONTINUE
  if ( NDEV>=1 ) NSTAR=0
  print '(''command: '',$)'
  read '(A)', char            ! COMMAND INPUT
  
  if ( char == 'p' ) then          ! REPLOT
     go to 1000
  else if ( char == 'a' ) then     ! CHANGE DATA
     NPR=NPR+1
     IPR=IPR+1
     if ( IM == 0 ) go to 50
  else if ( char == 'c' ) then     ! CHANGE DATA
     IR = 0
     NPR= 1
     IPR= 1
     NDEV = 0
     if ( IM == 0 ) go to 50
     if ( IM == 1 ) then
        IPR= 2
        go to 60
     end if
  else if ( char == 'g' ) then    ! CHANGE GALAXY
     if ( multi == 1 )  then
        IR = 1
        NPR= 1
        IPR= 1
        if ( IM == 0 ) go to 50
        if ( IM == 1 ) then
           IPR= 2
           go to 60
        end if
     else
        print '(''  This mode is valid only for  .pub'')'
        go to 2000
     end if
  else if ( char == 'd' ) then   ! ERASE PLOT
!        call PGPAGE
     go to 2000
  else if ( char == 'h' ) then   ! MAKE COPY ON LASER PRINTER
     call PGEND
     print '(''Output file <'',a,''> : '',$)', hfile
     read '(a)', hfile0
     if ( hfile0 == ' ' ) hfile0=hfile
     hfile=extend(hfile0,'ps')
     call PGBEGIN(0,hfile//'/ps',1,1)
     call PGSCF(2)
     go to 1001
  else if ( char == 'm' ) then  ! MODE CHANGE
!        call PGPAGE
     go to 9000
  else if ( char == 'x' ) then  ! CHANGE X-SCALE
     print '(''  new x lower, upper limits = '',$)'
     read *, Xmin, Xmax
     go to 1000
  else if ( char == 'y' ) then  ! CHANGE Y-SCALE
     print '(''  new y lower, upper limits = '',$)'
     read *, Ymin, Ymax
     if ( IM == 0 .and. kind2 == 2 ) then
        if ( Ymin<0.0 .or. Ymax<0.0 ) then
           do J=1,IPR
              do I=1,ND(J)
                 if ( Y(I,J)>90.0 ) Y(I,J)=Y(I,J)-180.0
              end do
           end do
        end if
     end if
     go to 1000
  else if( char == 'z' ) then   ! CHANGE MAG.-SHIFT
     if ( IM == 0 ) then
        JDUM=1
        if ( NPR>1 ) then
           print '(''  profile no.='',$)'
           read *, JDUM
        end if
        print '(''  shift = <'',f7.3,''> '',$)', DYS(JDUM)
        read '(A7)', YSH(JDUM)
        if ( YSH(JDUM) /= ' ' ) read (YSH(JDUM),'(F7.0)') DYS(JDUM)
        write(YSH(JDUM),'(F7.3)') DYS(JDUM)
        do I=1,ND(JDUM)
           Y(I,JDUM)=Y(I,JDUM)+DYS(JDUM)
        end do
        go to 2000
     else
        go to 70
     end if
!   Masaru    05/15/86
  else if( char == '<' ) then   ! CUT INNER PART
     if ( IM == 0 ) then
        JDUM=1
        if ( NPR>1 ) then
           print '(''  profile no.='',$)'
           read *, JDUM
        end if
        print '(''  inner limit for x = '',$)'
        read *, XIN
        NDUM=0
        do I=1,ND(JDUM)
           if ( X(I,JDUM)>=XIN ) NDUM=NDUM+1
        end do
        MDUM = ND(JDUM)-NDUM
        do I=1,NDUM
           X(I,JDUM)=X(I+MDUM,JDUM)
           Y(I,JDUM)=Y(I+MDUM,JDUM)
        end do
        ND(JDUM)=NDUM
        if ( npr == 1 ) go to 1000
        print *, 'Type "p" for re-plot'
        go to 2000
     else
        go to 70
     end if
!   Masaru    05/15/86
  else if( char == '>' ) then   ! CUT OUTER PART
     if ( IM == 0 ) then
        JDUM=1
        if ( NPR>1 ) then
           print '(''  profile no.='',$)'
           read *, JDUM
        end if
        print '(''  outer limit for x = '',$)'
        read *, XOUT
        NDUM=0
        do I=1,ND(JDUM)
           if ( X(I,JDUM)<=XOUT ) NDUM=NDUM+1
        end do
        ND(JDUM)=NDUM
        if ( npr == 1 ) go to 1000
        print *, 'Type "p" for re-plot'
        go to 2000
     else
        go to 70
     end if
  else if( IM == 1 .and. char == 'e' ) then  ! ESTIMATE MAG.-SHIFT
     JDUM=2
     if ( IPR>2 ) then
        print '(''  data no.='',$)'
        read *, JDUM
        if ( JDUM<=1 .or. JDUM>IPR ) go to 2000
     end if
     print '(''  x lower, upper limits = '',$)'
     read *, FS(1,1), FE(1,1)
     SUM=0.0
     NW = 0
     do I=1,ND(JDUM-1)
        if ( X(I,JDUM-1)>=FS(1,1) .and. X(I,JDUM-1)<=FE(1,1) ) then
           SUM = SUM + Y(I,JDUM-1)
           NW = NW+1
        end if
     end do
     DYS(JDUM) = SUM / FLOAT(NW)
     SUM=0.0
     NW = 0
     do I=1,ND(JDUM-1)
        if ( X(I,1)>=FS(1,1) .and. X(I,1)<=FE(1,1) ) then
           SUM = SUM + (Y(I,JDUM-1)-DYS(JDUM))*(Y(I,JDUM-1)-DYS(JDUM))
           NW = NW+1
        end if
     end do
     SD = SQRT(SUM/FLOAT(NW-1))
     print '('' <DIFF> = '',F7.3,'' +-'',F7.3)', DYS(JDUM),SD
     if ( npr == 1 ) go to 1000
     print *, 'Type "p" for re-plot'
     go to 2000
  else if ( char == '0' ) then     ! RESTORE DEFAULT SCALES
     Xmin = Xmin0
     Ymin = Ymin0
     Xmax = Xmax0
     Ymax = Ymax0
     go to 1000
  else if( char == '.' ) then      ! CHANGE kind OF DOTS
     print *
     print '(''kind of plot symbol:  '' / &
          &  ''  (0=filled circle,   1=open circle,  '', &
          &  ''   2=filled square,   3=open square,  '' / &
          &  ''   4=cross[x],        5=plus[+],      '', &
          &  ''   6=filled triangle, 7=open triangle,'')'
     print '(''   8=asterisk,        9=small dot,    ''/ &
          &  ''  -1=full line,      -2=dashed line,  '', &
          &  ''  -3=dot-dash line,  -4=dotted line,'' / &
          &  ''  -5=dash-dot-dot-dot line '')'
     if ( npr>1 ) then
        print '(''profile no = '',$)'
        read *, j
     else
        j=1
     end if
     if ( j>=1 .and. j<=npr ) then
        print '(''  current symbol code ='',I2)', ipk(j)
        print '(''  Enter new symbol code = '',$)'
        read *, ipk(j)
        if ( ipk(j)<-5 .or. ipk(j)>9 ) go to 2000
        if ( ipk(j)>-1 ) then
           style(1,j)=Rstyle( ipk(j) )
        else
           ltype(j)=-ipk(j)
           if ( ltype(j)<0 .or. ltype(j)>6 ) goto 2000
        end if
     end if
     if ( npr == 1 ) go to 1000
     print *, 'Type "p" for re-plot'
     go to 2000
  else if ( char == '*' ) then   ! PLOT STAR PROFILE
     print '(''  sigma star = '',$)'
     read *, SIG
     if( SIG<=0.0001 .or. SIG>10. ) then
        NSTAR = 0
        go to 1000
     end if
     NSTAR = 1
     NDEV  = 0
     SSS = 0.542868/SIG**2     ! 0.542868 = 2.5*log(e)/2
     do I=1, MAXPNT
        SMU(I,1) = (I-1) * 0.04
        if ( SMU(I,1)<=0.001 ) SMU(I,1) = 0.001
        SR (I)   = SQRT(SMU(I,1)/SSS)
        SLOGR(I) = LOG10(SR(I))
        SR4  (I) = SQRT(SQRT(SR(I)))
        SMU(I,1) = SMU(I,1) + MU(1,1)
     end do
     write(Cstar,'(A14,F5.2,a1)') VSTAR,SIG,'"'
     go to 1000
  else if ( char == 'v' ) then   ! fit model profiles
     call FIT(X,Y,SR,SLOGR,SR4,SMU,FS,FE,bulge,kind,ND,NPR,NDEV,Cparm,cer,eEll)
     if ( npr == 1 ) go to 1000
     print *, 'Type "p" for re-plot'
     go to 2000
  else if ( char == '?' ) then
     call HELP
     go to 2000
  else if ( char == 'k' ) then     ! CHANGE kind OF PLOT
     print *
     print '('' kind of plot (+10=ellip., +20=P.A.)'' / &
          &      ''  (1=major,2=log major,3=major^(1/4),'' / &
          &      ''   4=mean, 5=log mean, 6=mean^(1/4),'' / &
          &      ''   7=surface brightness)'' )' 
     print '(''kind = '',$)'
     read *, kind
     go to 1
  else if ( char == 't' ) then     ! TYPE CURRENT PROFILE
     call DTYPE(X,Y,ND,NPR,1)
     if ( NPR>= 4 )      call DTYPE(X,Y,ND,NPR, 4)
     if ( NPR>= 7 )      call DTYPE(X,Y,ND,NPR, 7)
     if ( NPR>=10 )      call DTYPE(X,Y,ND,NPR,10)
     go to 2000
  else if( char == 'q' ) then      ! EXIT
     go to 999
  else
     print '(1X,''valid responses are '', &
          &       ''a,c,d,g,h,k,m,p,q,t,v,x,y,z,0,.,? <cr>'')'
     go to 2000
  end if
  go to 999
50 ig5k=1
  go to 5000
60 ig6k=1
  go to 8000 ! 6000
70 ig7k=1
  go to 8000 ! 7000
999 CONTINUE
  call PGEND
  
  stop
end program vplot

!**********************************************************************
subroutine DATAIN (filename,ident,nprf,W,Rmin,Rmax, &
     &             source,band,multi,deflt,IR,IM,last,only,irc)

!     This routine reads the profile data from the disk file.
!     The data are stored in the work area w(i,j).

! w(i,1) w(i,2) w(i,3) w(i,4) w(i,5) w(i,6)  w(i,7) w(i,8) w(i,9) w(i,10)
!   R    log(R)   MU     R4     RM   log(RM)  RM4   ELL     PA      EW   

  parameter  (MAXPNT=500)
  character  filename*50, file*50, extend*50, NGC*12, object*12
  character  ident*40,comment*30,source*35,band,ok,deflt(2)*40
  character  only*5
  dimension  w(MAXPNT,10), last(10)
  
  irc = 0
  ig2k=0
1000 continue
!      if ( IR == 1 ) go to 2000
  if ( IR == 0 ) then
     print '(/''  Type Source filename'')'
     print '(''  (.pr Assumed / <'',A40,''> ) = '',$)', deflt(1)
     read '(A)', file
     if ( file == ' ' ) file=deflt(1)
     IQ=1
     if ( deflt(1) == file ) IQ=0
     deflt(1)=file
  end if
  if ( IR == 1 ) ig2k=1    !go to 2000
  if ( index(file,'.PUB') == 0 .and. index(file,'.pub') == 0 .and. ig2k == 0 ) then
     multi=0
     filename = extend(file,'pr')
     open (11,file=filename,form='FORMATTED',status='OLD',err=9999)
     read (11,'(1X)')
     read (11,'(3X,A40,T45,A1)') ident,band
  else
     if ( ig2k == 0 ) then
        multi=1
        filename=file
     end if
2000 print '(/ ''  Enter object name as NGC 3115 <'',A12,''> : '',$)', deflt(2)
     read '(A)', NGC
     if ( NGC == ' ' ) NGC=deflt(2)
     deflt(2)=NGC
     print '('' '')'
     
     open (11,file=filename,form='FORMATTED',status='OLD',err=9999)
     ok='N'
     
     Nfile = 0
1    read (11,'(1X,T45,A35)',end=998) source
     Nfile = Nfile +1
     read (11,'(3X,A10,A30,T45,A1)') object,comment,band
     IFLG = 0
     do i=1,10
        if ( IQ == 0 .and. last(i) == Nfile ) IFLG = 1
     end do
     if ( index(object,NGC) /= 0 .and. IFLG == 0 ) then
        print '(/ 1X,A10,A20,2X,A1,''-band''/'' ''A35,2X, &
             &  ''Is this file OK ? ( y / <n> ) : '',$)', &
             &  object,comment(1:20),band,source
        read '(A1)', ok
        print '(//)'
     end if
     if ( ok == 'Y' .or. ok == 'y' ) then
        ident=object(1:10)//comment
        do i=1,10
           if ( last(i) == 0 ) then
              last(i)=Nfile
              go to 6000
           end if
        end do
        go to 6000
     else
        do i=1,4
           read (11,'(1X)')
        end do
        do i=1,MAXPNT
           read (11,'(4X,F8.2,1X,F8.3,1X,F7.3)') DUM1,DUM2,DUM3
           if ( DUM1==0. .and. DUM2==0. .and. DUM3==0. ) go to 1
        end do
     end if
998  close(11)
     print *
     print '('' No such galaxy found !'')'
     print '(''  Retry ? ( <y> / n ) '',$)'
     read '(A)', ok
     if ( ok == 'N' .or. ok == 'n' ) then
        irc = 9001
        return 
     end if
     go to 1000
  end if
  
6000 do i=1,4
     read (11,'(1X)')
  end do
  if ( multi == 1 .and. index(source,'E-W') /= 0 ) then
     do i=1,MAXPNT
        read (11,'(4X,F8.2,1X,F8.3,1X,F7.3,1X,F6.3,T43,3X,F8.2, &
             &     1X,F8.3,9X,F6.3,T87,F5.3,F10.2,F10.3)', &
             &    end=999) ( w(i,J),J=1, 10 )
        if ( w(i,1) == 0. .and. w(i,2) == 0. ) go to 999
        if ( w(i,2)<=-3.0 ) w(i,2)=-5.0
        if ( w(i,6)<=-3.0 ) w(i,6)=-5.0
        if ( IM == 1 .and. I>1 ) then      ! P.A. DISCONTINUITY
           DEF = w(i,9) - w(i-1,9)
           if( ABS(DEF)>90.0 .and. w(i,9)>90.0 )  w(i,9) = w(i,9) - 180.0
           if( ABS(DEF)>90.0 .and. w(i,9)<=90.0 ) w(i,9) = w(i,9) + 180.0
        end if
     end do
  else
     do i=1,MAXPNT
        read (11,'(4X,F8.2,1X,F8.3,1X,F7.3,1X,F6.3,T43,3X,F8.2, &
             &     1X,F8.3,9X,F6.3,T87,F5.3,F10.2)',end=999) &
             &     ( w(i,J),J=1, 9 )
        if( w(i,1) == 0. .and. w(i,2) == 0. ) go to 999
        if ( IM == 1 .and. I>1 ) then
           DEF = w(i,9) - w(i-1,9)
           if( ABS(DEF)>90.0 .and. w(i,9)>90.0 )  w(i,9) = w(i,9) - 180.0
           if( ABS(DEF)>90.0 .and. w(i,9)<=90.0 ) w(i,9) = w(i,9) + 180.0
        end if
     end do
  end if
999 nprf = i - 1
  CLOSE(11)
  
  if ( w(1,1) == 999.0 ) then
     print '('' This data have only a mean profile !'')'
     only='MEAN '
     do i=1,nprf
        w(i,1) = w(i,5)        ! R = RM
        w(i,2) = w(i,6)        ! log(R) = log(RM)
        w(i,4) = w(i,7)        ! R4 = RM4
     end do
  end if
  if ( w(1,5) == 999.0 ) then
     print '('' This data have only a major-axis profile !'')'
     only='MAJOR'
     do i=1,nprf
        w(i,5) = w(i,1)          ! RM = R
        w(i,6) = w(i,2)          ! log(RM) = log(R)
        w(i,7) = w(i,4)          ! RM4 = R4
     end do
  end if
  
  Rmin = w(1,1)
  Rmax = w(1,1)
  do i = 2, nprf
     Rmin = min(Rmin,w(i,1))
     Rmax = max(Rmax,w(i,1))
  end do
  
  IR = 0
  return
  
9999 print '(/1x,a1)', char(7)
  print '(''  file { '',a20,''... } does not exist !'')',  filename(1:20)
  go to 1000
  
end subroutine DATAIN

!**********************************************************************
subroutine help

!      This routine prints the Help messages on the display.

  character H1(10)*60, H2(8)*60, H3(6)*60
  DATA H1 / &
       &  'OPTIONS:  ? = Type this HELP listing                        ', &
       &  '          p = Replot current graph                          ', &
       &  '          c = Change file                                   ', &
       &  '          g = Change data in the same file                  ', &
       &  '          d = Delete plot                                   ', &
       &  '          k = Kind:     (+10=Ellip., +20=P.A.)              ', &
       &  '                    1 = Rmajor,          4 = Rmean,         ', &
       &  '                    2 = log Rmajor,      5 = log Rmean,     ', &
       &  '                    3 = Rmajor^(1/4),    6 = Rmean^(1/4),   ', &
       &  '                            7 = Surface Brightness          '/
  DATA H2/ &
       &  '          h = Copy plot on laser printer                    ', &
       &  '          m = MODE Change (PROFILE/COMPARISON)              ', &
       &  '          v = MODEL fitting                                 ', &
       &  '          e = Evaluate magnitude difference (for mode-1)    ', &
       &  '          x = Change x-scale                                ', &
       &  '          y = Change y-scale                                ', &
       &  '          z = Change magnitude-shift (delta)                ', &
       &  '          0 = restore default plot scales                   '/
  DATA H3 / &
       &  '          . = Change plot symbols,                          ', &
       &  '          t = Type current profile                          ', &
       &  '          * = Plot star profile                             ', &
       &  '          < = Cut inner data                                ', &
       &  '          > = Cut outer profile                             ', &
       &  '          q = Quit from this program                        '/
! Masaru modified above 3 lines 05/15/86
  do I=1,10
     print '('' '',A60)', H1(I)
  end do
  do I=1,8
     print '('' '',A60)', H2(I)
  end do
  do I=1,6
     print '('' '',A60)', H3(I)
  end do
  
  return
end subroutine help
!**********************************************************************
subroutine COPY(W,R,LOGR,R4,MU,RM,LOGRM,R4M,ELL,PA,EW,K,NPRF)

!     This routine copy the data in the work area W(i,j) to
!     the array whose names are more meaningful.

!     W(I,1)    W(I,2)    W(I,3)    W(I,4)    W(I,5)    W(I,6)    W(I,7)      
!       R       LOG(R)      MU        R4        RM      LOG(RM)     RM4      
!     W(I,8)    W(I,9)    W(I,10)
!      ELL        PA        EW      

  parameter (MAXPNT=500)
  real*4    LOGR(MAXPNT,10), LOGRM(MAXPNT,10), MU(MAXPNT,10)
  dimension R(MAXPNT,10),  R4(MAXPNT,10)
  dimension RM(MAXPNT,10), R4M(MAXPNT,10)
  dimension ELL(MAXPNT,10), PA(MAXPNT,10) 
  dimension EW(MAXPNT,10), W(MAXPNT,10)
  
  do I=1,NPRF
     R(I,K)     =W(I,1)
     LOGR(I,K)  =W(I,2)
     MU(I,K)    =W(I,3)
     R4(I,K)    =W(I,4)
     RM(I,K)    =W(I,5)
     LOGRM(I,K) =W(I,6)
     R4M(I,K)   =W(I,7)
     ELL(I,K)   =W(I,8)
     PA(I,K)    =W(I,9)
     EW(I,K)    =W(I,10)
  end do
!
  return
end subroutine COPY
!**********************************************************************
subroutine INTERP(X, Y, NPTS, NTERMS, XIN, YOUT)
!     POLYNOMIAL INTERPOLATION
!     DESCRIPTION OF PARAMETERS
!     X      = ARRAY OF DATA POINTS OF INDEPendENT VARIABLE
!     Y      = ARRAY OF DATA POINTS OF DEPendENT VARIABLE
!     NPTS   = NUMBER OF PAIRS OF DATA POINTS
!     NTERMS = NUMBER OF TERMS IN FITTING POLYNOMIAL = ORDER + 1
!     XIN    = INPUT VALUE OF X
!     YOUT   = INTERPOLATED VALUE OF Y
!
!     AUTHOR : John KORMENDY
!     UPDATE : Masaru HAMABE
  parameter        (MAXPNT=500)
  DOUBLE PRECISION DELTAX, DELTA, A, PROD, SUM
  dimension        X(MAXPNT), Y(MAXPNT)
  dimension        DELTA(10), A(10)
 
!     Search for appropriate value of X(1)

  do I=1,NPTS
     if ( XIN<X(I) ) then
        I1 = I - NTERMS/2
        if( I1<=0 ) I1 = 1
        go to 1000
     else if( XIN == X(I) ) then
        YOUT = Y(I)
        return
     end if
  end do
  I1 = NPTS - NTERMS + 1
1000 I2 = I1 + NTERMS - 1
  if ( NPTS<I2 ) then
     I2 = NPTS
     I1 = I2 - NTERMS + 1
     if ( I1<=0 ) then
        I1=1
        NTERMS = I2 - I1 + 1
     end if
  end if
  
  !     Evaluate deviations delta
  
  DENOM = X(I1 + 1) - X(I1)
  DELTAX = (XIN - X(I1))/DENOM
  do I=1, NTERMS
     IX = I1 + I - 1
     DELTA(I) = (X(IX) - X(I1))/DENOM
  end do
  
  !     Accumulate coefficients A
  
  A(1) = Y(I1)
  do K=2, NTERMS
     PROD = 1.
     SUM = 0.
     Imax = K - 1
     IXmax = I1 + Imax
     do I=1, Imax
        J = K - I
        PROD = PROD*(DELTA(K) - DELTA(J))
        SUM = SUM - A(J)/PROD
     end do
     A(K) = SUM + Y(IXmax)/PROD
  end do
  
!     Accumulate sum of expansion
  
  SUM = A(1)
  do J=2, NTERMS
     PROD = 1.
     Imax = J - 1
     do I=1, Imax
        PROD = PROD*(DELTAX - DELTA(I))
     end do
     SUM = SUM + A(J)*PROD
  end do
  YOUT = SUM
  
  return

end subroutine INTERP

!**********************************************************************
subroutine DTYPE(X,Y,ND,NPR,IS)

!     This routine prints the current data on the display.

  parameter (MAXPNT=500)
  dimension X(MAXPNT,10), Y(MAXPNT,10), ND(10)
  
  print *
  NEND=min(IS+2,NPR)
  NDUM=ND(IS)
  do J=IS,NEND
     NDUM=max(NDUM,ND(J))
  end do
  do I=1,NDUM
     print '(1X,I10,3(2F10.3,2X))', I-1,(X(I,J),Y(I,J),J=IS,NEND)
  end do
  
  return

end subroutine DTYPE

!**********************************************************************
subroutine LOADXY (X,Y,R,LOGR,R4,RM,LOGRM,R4M,MU, &
     &             MU2,ELL,PA,K1,K2,I1,J1,I2,J2)
!     This routine loads the data to be plotted into the work area
!     X(i),y(i).
  
  parameter (MAXPNT=500)
  real*4 LOGR(MAXPNT,10), LOGRM(MAXPNT,100)
  real*4 MU(MAXPNT,10), MU2(MAXPNT,10)
  dimension R(MAXPNT,10),  R4(MAXPNT,10)
  dimension RM(MAXPNT,10), R4M(MAXPNT,10)
  dimension ELL(MAXPNT,10), PA(MAXPNT,10)
  dimension X(MAXPNT,10), Y(MAXPNT,10)
  
  if( K1 == 1 ) X(I1,J1)=     R(I2,J2)
  if( K1 == 2 ) X(I1,J1)=  LOGR(I2,J2)
  if( K1 == 3 ) X(I1,J1)=    R4(I2,J2)
  if( K1 == 4 ) X(I1,J1)=    RM(I2,J2)
  if( K1 == 5 ) X(I1,J1)= LOGRM(I2,J2)
  if( K1 == 6 ) X(I1,J1)=   R4M(I2,J2)
  if( K1 == 7 ) X(I1,J1)=    MU(I2,J2)
  
  if( K2 == 0 ) Y(I1,J1)= MU2   (I2,J1)
  if( K2 == 1 ) Y(I1,J1)= ELL   (I2,J1)
  if( K2 == 2 ) Y(I1,J1)= PA    (I2,J1)
  
  return
end subroutine LOADXY
!**********************************************************************
subroutine PLIMIT(X,Y,Xmin,Xmax,Ymin,Ymax,ND,NPR,K1,K2,IM)

!     This routine calculates the ranges of the ordinate and the
!     abscissa of the frame.

  parameter (MAXPNT=500)
  dimension X(MAXPNT,10),Y(MAXPNT,10),ND(10)
  
  Xmin = X(1,1)
  Xmax = X(1,1)
  Ymin = Y(1,1)
  Ymax = Y(1,1)
  do J=1,NPR
     do I=1, ND(J)
        Xmin = min(Xmin,X(I,J))
        Xmax = max(Xmax,X(I,J))
        Ymin = min(Ymin,Y(I,J))
        Ymax = max(Ymax,Y(I,J))
     end do
  end do
  
  Xmin = 0.0
  if ( K1 == 2 .or. K1 == 5 )  Xmin = -1.0
  if ( K1 == 7 )  Xmin = (INT(2.0*Xmin) - 1.0)/2.0
  Xmax = (INT(2.0*Xmax)  + 1.0)/2.0
  
  if ( IM == 0 ) then
     Ymin = INT(Ymin)
     if ( Ymin == 0.0 ) Ymin = - 0.2
     Ymax = INT(Ymax) + 1
     if ( Ymin < -1. ) Ymin = -1.
     if ( Ymax >  30.) Ymax =  30.
     if ( K2 == 1 ) then
        Ymin = -0.1
        Ymax =  1.1
     else if ( K2 == 2 ) then
        Ymin = 180.0
        Ymax =   0.0
     end if
  else
     if ( K2 == 0 ) then
        Ymin = INT(Ymin/0.05+0.5)*0.05 - 0.05
        Ymax = INT(Ymax/0.05+0.5)*0.05 + 0.05
     else if( K2 == 1 ) then
        DUM = max( Ymax,-Ymin, 0.1 )
        DUM = INT(DUM/0.1)*0.1
        Ymin =  DUM
        Ymax = -DUM
        if ( Ymin>  1.0 ) Ymin =  1.0
        if ( Ymax< -1.0 ) Ymax = -1.0
     else if( K2 == 2 ) then
        DUMU = max(Ymax,10.0)
        DUMU = INT(DUMU/10.0+0.5)*10.0
        DUMD = min(Ymin,-10.0)
        DUMD = INT(DUMD/10.0-0.5)*10.0
        Ymin = DUMU
        Ymax = DUMD
        if ( Ymin>  90.0 ) Ymin =  90.0
        if ( Ymax> -90.0 ) Ymax = -90.0
     end if
  end if
  
  return
end subroutine PLIMIT
!**********************************************************************
subroutine TITLAX(IM,IPR,kind1,kind2,band,fname,S1,S2,SOUT)
  
  !     This routine plots the names of the axes.
  
  character  band(10), fname(10)*50,  xttl(8)*32, yttl(3,2)*16
  character  S1*40, S2*40, SOUT*60, C(10)*15
  
  DATA xttl /'   Major Axis   R (arcsec)      ', &
       &     '   Major Axis  log R (arcsec)   ', &
       &     '  Major Axis  R (arcsec)\\u1/4  ', &
       &     '  Mean Profile  R (arcsec)      ', &
       &     '  Mean Profile  log R (arcsec)  ', &
       &     ' Mean Profile  R (arcsec)\\u1/4 ', &
       &     '    \\gm  (mag arcsec\\u-2\\d)  ', &
       &     '        R(E-W)  (arcsec)        '/
  DATA yttl/'  \\gm( )      ','   Ellipticity  ',' Position Angle ', &
       &    ' \\gD\\gm ( - )','   delta Ellip. ','   delta  P.A.  '/
  
  yttl(1,1) = '  \\gm('//band(1)//')      '
  yttl(1,2) = ' \\gD\\gm ('//band(1)//'-'//band(2)//')'
  S1=xttl(kind1)
  S2=yttl(kind2+1,IM+1)
  do I=1,10
     C(I) = fname(I)(1:15)
  end do
  if ( IPR == 2 ) SOUT=C(2)
  if ( IPR == 3 ) SOUT=C(2)//C(3)
  if ( IPR == 4 ) SOUT=C(2)//C(3)//C(4)
  if ( IPR == 5 ) SOUT=C(2)//C(3)//C(4)//C(5)
  if ( IPR == 6 ) SOUT=C(2)(1:12)//C(3)(1:12)//C(4)(1:12) &
       &             //C(5)(1:12)//C(6)(1:12)
  if ( IPR>=7 ) SOUT=C(2)(1:10)//C(3)(1:10)//C(4)(1:10) &
       &             //C(5)(1:10)//C(6)(1:10)//C(7)(1:10)
  
  return
end subroutine TITLAX
!**********************************************************************
subroutine pltpar(Xmin,Xmax,Ymin,Ymax,nstar,ndev,Cparm,Cstar,cer,eEll)
  
!     This routine plots the parameters of the fitted models or
!     of the star profile.

  character  Cparm(2,2)*20, cer(2,2)*15,Cstar*25, eEll*3
  
  Xrange=Xmax-Xmin
  Yrange=Ymax-Ymin
  dX = Xrange/20.
  dY = Yrange/15.
  if ( NSTAR>=1 ) then
     call PGTEXT(Xmin+15*dX,Ymin+1.5*dY,Cstar)
  else if (  NDEV>=1 ) then
     call PGTEXT(Xmin+ 14*dX,Ymin+1.5*dY,Cparm(1,1))
     call PGTEXT(Xmin+ 14*dX,Ymin+2.5*dY,Cparm(2,1))
     if ( eEll == 'yes' ) then
        call PGSCH(0.5)
        call PGTEXT(Xmin+ 17*dX,Ymin+2.0*dY,cer(1,1))
        call PGTEXT(Xmin+ 17*dX,Ymin+3.0*dY,cer(2,1))
        call PGSCH(1.0)
     end if
     if ( ndev>=2 ) then
        call PGTEXT(Xmin+ 14*dX,Ymin+3.5*dY,Cparm(1,2))
        call PGTEXT(Xmin+ 14*dX,Ymin+4.5*dY,Cparm(2,2))
        if ( eEll == 'yes' ) then
           call PGSCH(0.5)
           call PGTEXT(Xmin+ 17*dX,Ymin+4.0*dY,cer(1,2))
           call PGTEXT(Xmin+ 17*dX,Ymin+5.0*dY,cer(2,2))
           call PGSCH(1.0)
        end if
     end if
  end if
  
  return
end subroutine pltpar
