      PROGRAM  vista_profile
C     
C     MODIFIED 1989-07-23 BY HAMABE
c     Updated: M.Hamabe 27/09/1990 (imfort version)
c     Updated: M.Hamabe 01/03/1991
c     Updated: M.Hamabe 19/03/1991  (SPIRAL.SIZE)
c     Updated: M.Hamabe  1991-09-10  (opninp,matrd)
c     Updated: M.Hamabe  1991-12-27  (suppress message)
c     Updated: M.Hamabe  1992-09-11  (display format changed for large radii)
c     Updated: M.Hamabe  1992-11-18  (overwrite parameters)
c     Updated: M.Hamabe  1995-06-29  (SECPPIX)
c     Updated: M.Hamabe  1996-01-12  (print center)
c     Updated: M.Hamabe  1996-08-28  (support FITS)
c     Updated: M.Hamabe  1996-09-30  (bug-fix)
c     Updated: M.Hamabe  1999-07-23  (omit IMFORT)
c     Updated: M.Hamabe  1999-08-16  (increase NPROFI)
c     Updated: M.Hamabe  1999-08-19  (fixed axial-ratio; CDELT1 in degree)
c     Updated: M.Hamabe  1999-09-05  (make a new subroutine for param.input)
c     Updated: M.Hamabe  2000-07-24  (bugfix; error recovery)
c     Updated: M.Hamabe  2002-10-21  (DLINE=blank)
      
      parameter (maxdim=1024)
      
      character	 image*80,title*18,band*2
      character	 tabfile*30, tabl*30, extend*30
      integer	 im, irc
      dimension  g(maxdim*maxdim)
      logical    INTER, CENTER, LOGSC, ERRLOG, NOTFRE, ANGFRE, RATFIX
      
      NLP =16
      LOUT=21
      
      call opninp (1,im,0,image,title,iext,jext,irc,*999)
      
      call clargc (2, tabl, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter output profile-table name: '',$)')
	 read (*,*) tabl
      end if
      tabfile=extend(tabl,'pr')
      open (LOUT, file=tabfile,access='SEQUENTIAL')
      
C     -----  color band
      call GETKEYS(im,'BAND    ',band,irc)
c     call GETKEYS(im,'FILTNAM1',filtname,irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +      ''Enter color band (A2)     ===> '',$)')
         READ (*,'(a)') band
         irc=0
      end if
      write(*,'(''     Band = '',a2)') band
      
C     -----  pixel scale
      call GETKEYE(im,'CDELT1',secppix,irc)
      if ( irc.ne.0 ) call GETKEYE(im,'SECPPIX ',secppix,irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +      ''Enter pixel scale (arcsec/pixel)     ===> '',$)')
         READ (*,*) secppix
         irc=0
      end if
      secppix=abs(secppix)
      if ( secppix.lt.10/3600.0 ) secppix=secppix*3600.0
      if ( secppix.lt.0.001 .or. secppix.gt.10.0 ) irc=1
      write(*,'(''     Pixel size = '',f7.3,'' arcsec'')') secppix
      
C     ----- Sky surface brightness
      call GETKEYE(im, 'UNIT-MAG', sky, irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +      ''Enter surface brightness unit (sky)  ===> '',$)')
         READ (*,*) sky
         irc=0
      end if
      write(*,'(''     Sky = '',f7.3,'' mag arcsec**(-2)'')') sky

      call GETKEYJ(im,'BLANK',iblank,irc)
      if ( irc.ne.0 ) then
         call GETKEYJ(im,'IGNRVAL',iblank,irc)
         if ( irc.ne.0 ) then
            irc=0
            blank=-32768.0
            write(*,'(''BLANK is not defined'')')
         else
            write(*,'(''IGNRVAL is assumed to be BLANK'')')
            blank=iblank
         end if
      else
         blank=iblank
      end if
         write(*,'('' ---> BLANK is assumed to '',f15.7)') blank

      call paramin(XCAX,YCAX,FINC,POSANG,ANGSGN,ANGAX,boa_0,
     +   NSTEP,MPA,NSINC,NAKA,NITER,NROUGH,LOM1,LOM2,NLP,
     +   INTER,CENTER,LOGSC,ERRLOG,NOTFRE,ANGFRE,RATFIX)
      
      WRITE(*,*)
      
C     *** READ MATRIX ***
      CALL MATRD(im,G,IEXT,JEXT,irc)
      
      CALL SUBPROF(title,G,IEXT,JEXT,secppix,sky,band,NLP,LOUT,
     +   XCAX,YCAX,FINC,POSANG,ANGSGN,ANGAX,boa_0,blank,
     +   NSTEP,MPA,NSINC,NAKA,NITER,NROUGH,LOM1,LOM2,
     +   INTER,CENTER,LOGSC,ERRLOG,NOTFRE,ANGFRE,RATFIX)
      
      stop
      
 999  call PUTEMSG(irc)
      stop
      
      end

c-------------------------------------------------------------------------

      subroutine paramin(XCAX,YCAX,Finc,POSANG,ANGSGN,ANGAX,boa_0,
     +   NSTEP,MPA,NSINC,NAKA,NITER,NROUGH,LOM1,LOM2,NLP,
     +   INTER,CENTER,LOGSC,ERRLOG,NOTFRE,ANGFRE,RATFIX)

      character  NR, reverse*3, meanpa*3, cnum*10
      character  solcen*3, fixpa*3, fixab*3, iiter*3, maklog*3
      logical    INTER, CENTER, LOGSC, ERRLOG, NOTFRE, ANGFRE, RATFIX

C     ### Initialize parameters

      Finc = 1.0                        ! Iteration increment

      posang=0.0
      NR='N'
      call clargc (3, reverse, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Image is reverse? ( y/<n> ) ===> '',$)')
         READ (*,'(A)') reverse
         irc=0
      end if
      if ( reverse(1:1).eq.'y' ) then
         NR='R'
      end if
      if ( NR.EQ.'N' ) then
         WRITE(*,*) 'Image is normal   (no mirror reflection)'
         ANGSGN = -1.0                  ! No mirror reflections
      else if ( NR.EQ.'R' ) then
         WRITE(*,*) 'Image is reversed (mirror reflection)'
         ANGSGN =  1.0
      end if
      
      call clargr (4, POSANG, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter Position angle: '',$)')
	 read (*,*) POSANG
         irc=0
      end if
      if ( POSANG.LT.0.0 ) then
         POSANG = -POSANG
         ANGSGN = 1.0
      end if
      
C     ----- Center of galaxy
      call clargr (5, xcax, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter x-coordinate of the center of galaxy: '',$)')
         read (*,*) xcax
         irc=0
      end if
      call clargr (6, ycax, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter y-coordinate of the center of galaxy: '',$)')
         read (*,*) ycax
         irc=0
      end if
      
C     ----- Position angle of the major axis of the object
      call clargr (7, dum, irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +      ''Enter Position angle of the object (top ->left): '',$)')
         read (*,*) dum
         irc=0
      end if
      ANGAX = 180.0 - DUM ! <= angle between i-axis and major-axis (clockwise)
C					     ANGAX = 270.0-DUM

C     -----  keyword is Mean Position Angle
      MPA = 3              ! DEFAULT radius+1 in which mean PA used
      NOTFRE = .FALSE.
      call clargc (8, meanpa, irc)
c     write(*,'(
c     +    ''Use mean position angle for center ( y/<n> ) ===> '',$)')
c     READ (*,'(A)') YN
      if ( meanpa.eq.'yes' ) then
         write(*,'(''How many contours do you use to calculate the '',
     +      ''mean position angle? <mpa=3> ===> '',$)')
         read (*,'(a)') cnum
         if ( cnum.ne.' ' )  read (cnum,'(BN,i10)') mpa
         NOTFRE = .TRUE.
      end if
      irc=0
      
C     -----  keyword RADIUS=
      call clargi (9, NSTEP, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter Maximum radius (r): '',$)')
         read (*,*) NSTEP
         irc=0
      end if

C     -----  keyword M=
      call clargi (10, NSINC, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Enter Number of SINC interpolation (m): '',$)')
         read (*,*) NSINC
         irc=0
      end if

C     -----  keyword is LOGSC
      LOGSC  = .FALSE.
c     write(*,'(
c    +    ''Would you like to use log-interval ? ( y/<n> ) ===> '',$)')
c     READ (*,'(A)') YN
c     if ( yn.eq.'y' ) then
c         LOGSC = .TRUE.
c         write(*,'(''     delta log(r) ===> '',$)')
c         READ (*,*) DLTLGR
c         FCTRAD= 10.0**(DLTLGR)
c     end if

C -----  keyword N=
      if ( LOGSC ) then
         NAKA   = 0
         write(*,
     +      '(''Number of contours in 1-pix. interval (n) ===> '',$)')
         READ (*,'(A10)') CNUM
         if ( CNUM.EQ.' ' ) CNUM='         0'
         READ (CNUM,'(BN,I10)') NAKA
      else
         NAKA=NSTEP
      end if

C     -----  keyword ITER=
      NITER = 2                 ! Number of iterations
      NROUGH = NITER            ! Number with bilinear interpolation
      call clargi (11, NROUGH, irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +         ''Enter Number of Fast BILINEAR interpolation= '',$)')
         read (*,*) NROUGH
         irc=0
      end if
      call clargi (12, NDUM, irc)
      if ( irc.ne.0 ) then
         write(*,'(
     +      ''Enter Number of Slower SINC interpolation= '',$)')
         read (*,*) NDUM
         irc=0
      end if
      NITER  = NROUGH + NDUM

C     -----  keyword CENTER
      CENTER = .FALSE.
      call clargc (13, solcen, irc)
c     write(*,'(''Solve the center ?       ( y/<n> ) ===> '',$)')
c     READ (*,'(A)') YN
      if ( solcen.eq.'yes' ) center=.true.

C     -----  keyword ANGFRE
      ANGFRE = .TRUE.
      call clargc (14, fixpa, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Fix the position angle ? ( y/<n> ) ===> '',$)')
         READ (*,'(A)') fixpa
         irc=0
      end if
      if ( fixpa(1:1).eq.'y' ) ANGFRE=.false.

c     ===== for fiexd b/a (added 19 Aug., 1999)
      RATFIX = .FALSE.
      call clargc (15, fixab, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Fix the axial ratio ? ( y/<n> ) ===> '',$)')
         READ (*,'(A)') fixab
         irc=0
      end if
      if ( fixab(1:1).eq.'y' ) then
         RATFIX=.TRUE.
         call clargr (16,boa_0,irc)
         if ( irc.ne.0 ) then
            write(*,'(''axial ratio ?  = '',$)')
            READ (*,*) boa_0
            irc=0
         end if
      end if

C     -----  Definition of the omitting radius range 
      call clargi (17, LOM1, irc)
      if ( irc.ne.0 ) LOM1 = 0

      call clargi (18, LOM2, irc)
      if ( irc.ne.0 ) LOM2 = 0

C     -----  keyword is NOINT
      INTER = .TRUE.              ! use interaction to decide when to stop
      call clargc (19, iiter, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Interactive iteration ? ( <y>/n ) ===> '',$)')
         READ (*,'(A)') iiter
         irc=0
      end if
      if ( iiter(1:1).eq.'n' ) then
         INTER = .FALSE.
      end if

C     -----  keyword is LOG
      ERRLOG = .FALSE.
      call clargc (20, maklog, irc)
      if ( irc.ne.0 ) then
         write(*,'(''Make the log of iteration? ( <y>/n ) ===> '',$)')
         READ (*,'(A)') maklog
         irc=0
      end if
      if ( maklog(1:1).eq.'y' ) then
         errlog = .true.
         open (NLP,  file='profile.log',access='SEQUENTIAL')
      end if

c     -------------------------------------------------------------

C     Make sure that the limits on contours
c         ( R-NSTEP, N-NAKA, and M-NSINC )
C     All exist and have legitimate values.

      if ( LOGSC ) then
    3    if ( NSTEP.le.0 ) then
            write(*,'(''Enter maximum radius R ===> '',$)')
            read (*,*) NSTEP
            go to 3
         end if
         if ( NAKA.eq.0 ) NAKA  = NSINC
      else
    4    if ( NSTEP.le.0 .and. NAKA.le.0 ) then
            if ( NSINC.gt.0 ) then
               NSTEP = NSINC
               NAKA = NSINC
            else
               write(*,'(
     +            ''Number n of profile steps in pixels: '',$)')
               read (*,*) NSTEP
               NAKA  = NSTEP
               write(*,*)'NAKA',NAKA,' NSTEP',NSTEP
               go to 4
            end if
         else if ( NSTEP.le.0 ) then
            NSTEP = NAKA
         else
            NAKA  = NSTEP
         end if
      end if

C@@@  
      if ( NSINC.gt.NAKA ) NSINC=NAKA

      return
      end
